#
# Authors:	Bernd Pfrommer
#
# Description:	Paratec top level makefile.
#
# Version:	@(#)Makefile.mk 1.2 98/06/05
#

DEPTH	= .

include $(DEPTH)/conf.mk
include $(DEPTH)/vars.mk

#
#  ---- rules for making the paratec files ------
#
#
PARATECCODEDIRS = src/para

paratec : paratecobjects
paratecobjects:
	@echo Making $(TARG).
	@for i in $(PARATECCODEDIRS) ; do \
		echo "	"$$i: ; (cd $$i; $(MAKE) -f ../../conf.mk -f ../../vars.mk -f Makefile -e $(TARG)); \
	done
cleanparatec:
	@echo Making $(TARG)
	@for i in $(PARATECCODEDIRS) ; do \
		echo "	"$$i: ; (cd $$i; $(MAKE) -f ../../conf.mk -f ../../vars.mk -f Makefile -e $(TARG)); \
	done
#
#  ---- rules for making the shared files ------
#
#
SHAREDCODEDIRS  = src/shared
shared : sharedobjects
sharedobjects:
	@echo Making $(TARG)
	@(cd $(SHAREDCODEDIRS) ; $(MAKE) -f ../../conf.mk -f ../../vars.mk -f Makefile -e  $(TARG));
cleanshared:
	@echo Making $(TARG)
	@for i in $(SHAREDCODEDIRS) ; do \
		echo "	"$$i: ; (cd $$i; $(MAKE) -e -f ../../conf.mk -f ../../vars.mk -f Makefile $(TARG)); \
	done
#
#  ---- rules for making the microbench files ------
#
#
MICROBENCHCODEDIRS  = src/microbench
microbench  : microbenchobjects

microbenchobjects:
	@echo Making $(TARG).
	@for i in $(MICROBENCHCODEDIRS) ; do \
		echo "	"$$i: ; (cd $$i; $(MAKE) -e -f ../../conf.mk -f ../../vars.mk -f Makefile $(TARG)); \
	done

cleanmicrobench:
	@echo Making $(TARG).
	@for i in $(MICROBENCHCODEDIRS) ; do \
		echo "	"$$i: ; (cd $$i; $(MAKE) -e -f ../../conf.mk -f ../../vars.mk -f Makefile $(TARG)); \
	done

#
#  ---- rules for making the tools ------
#
# for list of tools, see vars.mk
#
#
tools:
	@echo Making $(TARG)
	cd src/tools ; $(MAKE) -e -f ../../conf.mk -f ../../vars.mk -f Makefile $(TARG)
cleantools:
	@echo Making $(TARG)
	cd src/tools ; $(MAKE) -e -f ../../conf.mk -f ../../vars.mk -f Makefile $(TARG)

#
#  ---- rules for cleaning the test results ---
#
# for list of tools, see vars.mk
#
cleantest:
	@echo Making $(TARG)
	@-\rm test/debug/*/output*/OUT*

