#
#                silicon in diamond structure
#
#                Young-Gui Yoon

#

#
# ---------------------- RELAXATION PARAMETERS -------------------------
#

# tell the code what to do, which is to relax stress/force
job relax

begin pw_jobs
pw_job scf
end pw_jobs

# pw_job scf

# inital step size for the relaxation
# maximum number of relaxation steps that should be done

relax_max_iter 0

# relax_accuracy: length of gradient g=(stress,force), at which iteration stops

relax_accuracy 0.001


# --------------------------- STRUCTURE --------------------------------
#
# the coordinates of the atoms
#

begin coordinates
newtype Si 0.0 1.0 
coord  0.125   0.125  0.125
coord -0.125  -0.125 -0.125
end coordinates

#
#  the lattice vectors in cartesian coordinates
#

begin latticevecs
coord     0.000     1.000     1.000
coord     1.000     0.000     1.000
coord     1.000     1.000     0.000
volume 262.6
end latticevecs

#
# -------------------- PW PROGRAM PARAMETERS -------------------------------
#

k_grid 2 2 2
k_grid_shift 0.5 0.5 0.5

number_bands 4
number_of_spins 2
exchange_correlation perdew_wang_91
# exchange_correlation perdew_burke_ernzerhof
gaussian_smearing 0.2
# randomize_diag_start_guess 20

diagsafety 3.0
accuracy_diag 1e-13
max_iter_diag 500

energy_cutoff 10
submatrix_energy_cutoff 3
mixing_energy_cutoff 5

screening_type previous
output_flags timing

# optimize insulator
