c
c
      subroutine mmtest

c
c     TESTS PERFORMANCE OF MATRIX-MATRIX MULTIPLIES
c     
      implicit none
c
c     maximum sizes
c

      integer 
     $     mmax, nmax, iodd, in, n,
     $     im, m, i, nloops

      parameter(nmax=10000,
     $          mmax=256)


      
      double precision
     $     t0,t1,nops, gimmetime
      external gimmetime
      
c
c     the work arrays etc
c

      complex(kind=8) 
     $     a((nmax+1)*mmax),
     $     b((nmax+1)*mmax),
     $     c((mmax+1)*(mmax+1)),
     $     dc1,dc0


      
      
c
c     -------------------------------------------------------------
c
c
c     multiplication constants
c
      dc0=0
      dc1=(1.d0,0.d0)
c
c     initialize
c

      do i=1, (nmax+1)*mmax
         a(i)=(1.d0,2.d0)
         b(i)=(3.d0, 4.d0)
      end do
      
      do i=1, (mmax+1)*(mmax+1)
         c(i)=0
      end do

      write(6,10)

      do iodd =0,1              ! whether the lda is n or n+1
         write(6,20) iodd
         do in=10,12
            n = 2**in
            write(6,30) n
            do im=1,8
               m=2**im
               nops = 8.d0*dble(m)*dble(m)*dble(n)
               nloops = max(int(1d8/nops),1)
               t0 = gimmetime()
               do i=1, nloops
                  m4_ifdef([CRAY],[
                  call cgemm('C','N',m,m,n,dc1,a(1),n+iodd,b(1),n
     $                 +iodd,dc0,c(1),m+iodd)
                  ],[
                  call zgemm('C','N',m,m,n,dc1,a(1),n+iodd,b(1),n
     $                 +iodd,dc0,c(1),m+iodd)
                  ])
               end do
               t1=gimmetime()
               write(6,40) m, dble(nloops)*nops/1d6/(t1-t0)
               call myflush(6)
            end do
         end do
      end do

      return

 10   format(' ######## MATRIX-MATRIX PERFORMANCE ########')
 20   format(' ======== LDA SHIFT: ',i2,' =========')
 30   format(' -------- N: ', i10,' ------------')
 40   format(' ........ m: ', i4,' MFLOPS:',f12.3)
      end

