c     @process extchk
c
      subroutine add_to_charge(ffts,
     $     gs, psi1r, psi2, weight, rho)
c     

      include 'use.h'
      implicit none             ! implicit? Just say no!
      include 'interface.h'

c
c     INPUT:
c     -----

c     

      type (fftstruc) ffts
      type (parallel_gspace) 
     $     gs                   ! gspaces where wavefn were computed

      double precision weight   ! the weight of the kpoint, with right sign

      complex(kind=8)
     $     psi1r(ffts%r_size),  ! first function in realspace
     $     psi2(gs%length)      ! psi2 in fourier space
      

c
c     INPUT/OUTPUT:
c     -------------

      complex(kind=8)
     $     rho(ffts%r_size)     ! perform rho(r)=rho(r)+conjg(psi1(r))*psi2(r)

c
c
c     1996 Bernd Pfrommer, UCB
c
c

c     ---------------- local variables ----------------------------------
       
      integer i

      complex(kind=8)
     $     cdsum,
     $     psi2r(ffts%r_size)   ! the fourier transform of psi2

      call fourier_transform(-1, ffts,
     $     gs,psi2,psi2r)
c
c     now add to charge with right weight
c

c      cdsum=0

      do i=1, ffts%r_size
c         cdsum = cdsum + conjg(psi1r(i))*psi1r(i)
         rho(i)=rho(i)+conjg(psi1r(i))*psi2r(i)*weight
      end do

c      write(9,*) 'length:', cdsum

      return

      end 



