c
      subroutine angular(p,gs,ffts, crys,bands,kpoints, wavefn,
     $     syms, pw_params,nrg)
c
      use all_to_all_module
      include 'use.h'
      implicit none             
      include 'interface.h'
      include 'all_to_all.h'

c
c     (c) 1996 Bernd Pfrommer
c     
c     Based on the decomp subroutine from Albertos code
c     I admit, this is a real mess, but I wont clean it up.
c     
c

c
c     INPUT:
c     -----

      type (symmetry) syms
      type (crystal) crys
      type (fftstruc) ffts      ! storage for FFT
      type (parallel_gspace) 
     $     gs(*)                ! gspaces where wavefn were computed

      type (band) bands         ! for nrk
      type (kpoint) kpoints     ! for the weights kpoints%w
      type (complex_gspace_array) 
     $     wavefn
      type (pw_parameter) pw_params ! to know if timing should be done
      
      integer nrg               ! number of radial grid points

c
c     OUTPUT:
c     ------
c
c     the symmetrized weights for the whole sphere, s, p, m=-1,0,1 and d
c     (first index). 
c
c     p index                   meaning
c     
c     1                         whole sphere
c     2                         s component
c     3                         p component
c     4                         px component
c     5                         py component
c     6                         pz component
c     7                         d component
c
c
      double precision
     $     p(7,crys%mxdatm,crys%ntype,bands%max,bands%nrk,crys%nspin)

c
c     DESCRIPTION:
c     -----------
c
c     computes the angular momentum decomposition with respect to
c     each site.
c
c

c
c     ---------------------- local variables ----------------------------
c
      integer 
     $     ndim,
     $     itype, ia, m, irk,is,n,l,i, idif,kk, nnx, nny, nnz, 
     $     ntot, icount,ir, idx, idy, idz, ic, b2, na2,nb
      complex(kind=8) 
     $     psi, psq, epfi, epfip, y11, y1m1, dw(nrg)
      double precision 
     $     t0, gimmetime, eps, delta, pi, cro(3), xdif, pi43,
     $     cs, cp, cd1, cd2,cd3,ootwopi, pi4, rcut, rcut2,rb(3),ra(3),
     $     qmod, fi, ys, yx, yy, yz, yxy, yyz, yzx, yxy2, yz2, r(3),
     $     qkcart(3), qr, sj0, sj1, sj2, prjc(10), pos(3), rc(3), 
     $     dr(3), drl, dintot, fip, gpk(3), gcart(3), gmag, gtr,cpc


      external gimmetime
      parameter(eps=1.d-8, delta=1d-5)
c
c     dynamic arrays 
c
      complex(kind=8), allocatable :: wpr(:,:,:,:), 
     $     dhd(:), psisq(:,:,:), sumtot(:,:),
     $     wprxyz(:,:,:,:,:,:) 

      double precision, allocatable :: psym(:,:,:,:,:,:),rga(:,:,:),
     $     wga(:,:,:), myslab(:)
c
c     ----- variables for the gspace loop ---------
c
      integer
     $     igv(4),fftn(4), ffth(4),igv3, irod,iord,igs

      double precision gv(3)

c
c     -------------------------------------------------------------------
c
      t0=gimmetime()

      nnx=ffts%fftsize(1)
      nny=ffts%fftsize(2)
      nnz=ffts%fftsize(3)
      ntot = nnx*nny*nnz
      dintot = 1.d0/dble(ntot)

c
c     initial coordinates, where the slab of this processor starts
c
      b2 = (nny*nnz)/gs(1)%nproc 
      na2 = mod(nny*nnz,gs(1)%nproc)
      icount=(b2*gs(1)%myproc+min(gs(1)%myproc,na2))*nnx


      write(9,200)
      write(9,100) nrg

      pi = 4.d0*atan(1.d0)
      pi4 = 4.d0*pi
      pi43 = pi4/3.d0
      ootwopi =1.d0/(atan(1.d0)*8.d0)

      cs = 1.d0/sqrt(4.d0*pi)
      cp = sqrt(3.D0)*cs
      cpc = sqrt(3.d0/(8.d0*pi))
      cd1 = sqrt(3.75D0)*cs
      cd2 = 2.d0*cd1
      cd3 = sqrt(1.25D0)*cs
c
c     compute the weights and abscissas for a Gauss-Legendre interpolation
c
c
      allocate(rga(nrg,crys%mxdatm,crys%ntype))
      allocate(wga(nrg,crys%mxdatm,crys%ntype))
      do itype=1, crys%ntype
         do ia=1, crys%natom(itype)

            call mygauleg(0,crys%mtsphere(itype),rga(1,ia,itype),
     $           wga(1,ia,itype),nrg)

         end do
      end do

      allocate(wpr(nrg,9,bands%max,crys%nspin))
      allocate(wprxyz(nrg,3,bands%max,crys%mxdatm,
     $     crys%ntype,crys%nspin))
      wprxyz=0
      allocate(psym(7,crys%mxdatm,crys%ntype,bands%max,bands%nrk,
     $     crys%nspin)) 
      psym=0
      
      allocate(sumtot(bands%max,crys%nspin))

      do irk = 1, bands%nrk     ! ------- loop over different kpoints -----
c
c     fourier transform the wave functions at this kpoint to
c     realspace, square, and fourier transform back
c     
         nb=bands%nband(irk,1)
         if(crys%nspin.gt.1) nb=max(bands%nband(irk,1),
     $        bands%nband(irk,2))

         allocate(psisq(gs(irk)%length, nb, crys%nspin))
         psisq=0
         allocate(dhd(gs(irk)%r_size))
         do is=1, crys%nspin    ! -------- loop over spins
            do n=1, bands%nband(irk,is) ! ------ loop over bands --
               call fourier_transform(-1, ffts, gs(irk),
     $              wavefn%data((n-1)*gs(irk)%length+1,irk,is),dhd(1))
               do i=1, gs(irk)%r_size
                  dhd(i)=dhd(i)*conjg(dhd(i))
               end do
               call fourier_transform(1, ffts, gs(irk),
     $              psisq(1,n,is),dhd(1))
            end do
         end do
         deallocate(dhd)
c     
         do itype = 1, crys%ntype ! ----- loop over different types ----
            do ia = 1, crys%natom(itype) ! ---- loop over different atoms ----
c
c              -------- now start the ugly loop over G-space -------------
c
               wpr=0
               sumtot=0

               fftn(1:3)=gs(irk)%fftsize(1:3)
               fftn(4)=gs(irk)%fftsize(3)
               ffth(:)=fftn(:)/2

               ndim=gs(irk)%length
               igs=0
               do iord=1, gs(irk)%lorder ! loop through x/y gspace 
               irod=gs(irk)%order(1,iord)
               igv(1)= irod/gs(irk)%fftsize(2)
               igv(2)= mod(irod,gs(irk)%fftsize(2))
               igv(3)= gs(irk)%order(2,iord)
               igv(4)= gs(irk)%order(3,iord)
               igv(:)= mod(igv(:)+ffth(:),fftn(:))-ffth(:) 
               gv(1:2)=dble(igv(1:2)) 
               gpk(1:2)=gv(1:2) +gs(irk)%rk(1:2)
               do igv3=igv(3),igv(4) ! loop over z axis
                  gv(3)=dble(igv3)
                  gpk(3)=gv(3) +gs(irk)%rk(3)
                  igs = igs + 1
                  
                  qmod = sqrt(gs(irk)%ekin(igs))
                  fip = dot_product(gpk,crys%rat(:,ia,itype))
                  epfip = exp(cmplx(0.d0,fip,kind=8))

                  gcart = matmul(crys%bvec,gv)
                  gmag = sqrt(dot_product(gcart, gcart)) ! length |G|
                  fi = dot_product(gv,crys%rat(:,ia,itype))
                  
                  if(gmag.gt.delta) then
                     gtr = crys%mtsphere(itype)*gmag ! |G|*|R|
                     epfi = exp(cmplx(0.d0,fi,kind=8))*pi4/gmag**3.d0*
     $                    (sin(gtr)-gtr*cos(gtr))
                  else
                     epfi = pi43*crys%mtsphere(itype)**3.d0 
                  endif
                  do is=1, crys%nspin ! -------- loop over spins
                     do n=1, bands%nband(irk,is) ! ------ loop over bands --
                        psq = psisq(igs,n,is)*epfi
                        sumtot(n,is) = sumtot(n,is)+ 
     $                       psisq(igs,n,is)*epfi
                     end do
                  end do

                  
c                 Express k+G in cartesian coordinates and compute
c                 the relevant spherical harmonics. Note that by
c                 dividing by qmod we only need to multiply components
c                 (See any book dealing with Ylms)
c
                  qkcart=matmul(crys%bvec,gpk)
                  if(qmod.gt.delta) qkcart=qkcart/qmod
c
c                 s, x, y, z, xy, yz, zx, x2-y2, 3z2-r2
c
                  ys = cs
c                 yx = cp*qkcart(1) ! this for px decomposition
c                 yy = cp*qkcart(2) ! this for py decomposition
                  y11 = -cpc*cmplx(qkcart(1),-qkcart(2),kind=8)  ! this for Y11
                  y1m1 = cpc*cmplx(qkcart(1),qkcart(2),kind=8) ! this for Y1m1

                  yz = cp*qkcart(3) ! Y_10
                  yxy = cd2*qkcart(1)*qkcart(2)
                  yyz = cd2*qkcart(2)*qkcart(3)
                  yzx = cd2*qkcart(3)*qkcart(1)
                  yxy2 = cd1*(qkcart(1)*qkcart(1)-qkcart(2)*qkcart(2))
                  yz2 = cd3*(3*qkcart(3)*qkcart(3)-1)
c
c                 Compute spherical Bessel functions at the radial grid points
c
                  do m = 1, nrg ! ---------- loop over radial grid
                     qr = qmod*rga(m,ia,itype)
                     sj0 = 1.D0
                     sj1 = 0.D0
                     sj2 = 0.D0
                     if (qr .ge. delta) then
                        sj0 = sin(qr)/qr
                        sj1 = (sj0-cos(qr))/qr
                        sj2 = 3*sj1/qr - sj0
                     endif
                     do is=1, crys%nspin ! -------- loop over spins
                        do n=1, bands%nband(irk,is) ! ------ loop over bands --
                           psi = wavefn%data((n-1)*ndim+igs,irk,is)
                           psi = psi*epfip

                           wpr(m,1,n,is) = wpr(m,1,n,is) + psi*sj0*ys
c                           wpr(m,2,n,is) = wpr(m,2,n,is) + psi*sj1*yx 
c                           wpr(m,3,n,is) = wpr(m,3,n,is) + psi*sj1*yy
                           wpr(m,2,n,is) = wpr(m,2,n,is) + psi*sj1*y1m1
                           wpr(m,3,n,is) = wpr(m,3,n,is) + psi*sj1*yz
                           wpr(m,4,n,is) = wpr(m,4,n,is) + psi*sj1*y11

                           wpr(m,5,n,is) = wpr(m,5,n,is) + psi*sj2*yxy
                           wpr(m,6,n,is) = wpr(m,6,n,is) + psi*sj2*yyz
                           wpr(m,7,n,is) = wpr(m,7,n,is) + psi*sj2*yzx
                           wpr(m,8,n,is) = wpr(m,8,n,is) + psi*sj2*yxy2
                           wpr(m,9,n,is) = wpr(m,9,n,is) + psi*sj2*yz2
                        end do
                     end do
                  end do        ! ------- loop over radial grid

               end do ; end do  ! ------- end of loop over Gspace

               call all_sum_all(wpr,nrg*9*bands%max*crys%nspin)
               call all_sum_all(sumtot, bands%max*crys%nspin)
               wprxyz(1:nrg,1:3,:,ia,itype,:)=wpr(1:nrg,2:4,:,:)

c
c              square and integrate the radial wave function
c              except for the px,py,pz quantum numbers
c     
               do is=1, crys%nspin
                  do n=1, bands%nband(irk,is)
                     do  l = 1, 9
                        prjc(l) = 0.D0
                        do  m = 1, nrg ! loop over radial grid
                           prjc(l) = prjc(l) + wga(m,ia,itype)*
     $                          (rga(m,ia,itype)*
     $                          abs(wpr(m,l,n,is)))**2.d0
                        end do
                        prjc(l)=prjc(l)*pi4**2.d0/crys%vcell
                     end do
                     
                     p(1,ia,itype,n,irk,is) = abs(sumtot(n,is))
     $                    /crys%vcell
                     p(2,ia,itype,n,irk,is) = prjc(1)
                     p(3,ia,itype,n,irk,is) = prjc(2)+prjc(3)+prjc(4)
                     p(7,ia,itype,n,irk,is) =
     $                    prjc(5)+prjc(6)+prjc(7)+prjc(8)+prjc(9)
                  end do
               end do
               
            end do              ! -------- end loop over atoms of one type
         end do                 ! -------- end loop over atomic types


         deallocate(psisq)
c
c        ------------- symmetrize the p-components for different m ----------
c
c        the m-components transform like vectors, and must be treated BEFORE
c        the square modulus is computed
c

c         write(9,*) 'unsymmetrized m-projectors:'
c         do is=1, crys%nspin
c            do n=1, bands%nband(irk,is)
c               do itype=1, crys%ntype
c                  do ia=1, crys%natom(itype)
c                     write(9,*)' wprxyz=', wprxyz(1:nrg,1:3,n,ia
c     $                    ,itype,is)
c                  end do
c               end do
c            end do
c         end do

         do is=1, crys%nspin
            do n=1, bands%nband(irk,is)

c               write(9,*) '------- band ',n,' -----------'
               do i=1,syms%ntrans ! --- loop over all symmetry operations
c                  write(9,*) 'symmat:'
c                  write(9,*) syms%rsymmat(:,:,i)
                  do itype=1,crys%ntype
                     do ia=1, crys%natom(itype)
c                        write(9,*) '#### destination atom:',ia
c     
c              -1
c     find mtrx    * (rat - tnp)
c
                        do l=1,3
                           cro(l) = 0.d0
                           do m=1,3
                              cro(l) = cro(l)+dble(syms%mtrx(m,l,i))*
     $                             (crys%rat(m,ia,itype)-syms%tnp(m,i
     $                             ))
                           end do
                        end do
c     
c     search for matching atom
c
                        do l=1,crys%natom(itype)
                           do m=1,3
                              xdif=abs(cro(m)-crys%rat(m,l,itype))
     $                             *ootwopi
                              idif = xdif + eps
                              if (abs(xdif-dble(idif)) .gt. eps) 
     $                             goto 26
                           end do
                           kk = l
                           goto 27
 26                        continue
                        end do
                        write(9,*) 'subroutine angular:',
     $                       'unable to find equivalent atom for k='
     $                       ,ia
                        stop
 27                     continue

c                        write(9,*) '*** from source:',kk
                        do l=1,3
                           dw=0
                           do m=1,3
                              dw(:) = dw(:)+syms%rsymmat(l,m,i)
     $                             *wprxyz(:,m,n,kk,itype,is)
                           end do
                           prjc(l) = 0.D0
                           do  m = 1, nrg ! loop over radial grid
                              prjc(l) = prjc(l) + wga(m,ia,itype)*
     $                             (rga(m,ia,itype)*
     $                             abs(dw(m)))**2.d0
                           end do
                           prjc(l)=prjc(l)*pi4**2.d0/crys%vcell
c                           write(9,*) 'l=',l-2,':',prjc(l)
                           psym(3+l,ia,itype,n,irk,is)=
     $                          psym(3+l,ia,itype,n,irk,is)+prjc(l)
                        end do
                     end do     ! -------- end loop over atoms of one type
                  end do        ! -------- end loop over atomic types
               end do           ! -------- end loop over symmetry operations
            end do              ! -------- end loop over bands
         end do                 ! -------- end loop over spins
      end do                    ! -------- end of loop over kpoints ------

      deallocate(wprxyz)

      deallocate(sumtot)
      deallocate(wpr)
      deallocate(wga) ; deallocate(rga);

c
c     symmetrize the projection weights
c

c
c     ------------- now symmetrize the integral and s, p, d total ----------
c

      do is=1, crys%nspin
         do irk = 1, bands%nrk
            do n=1, bands%nband(irk,is)
c
c              now average by using all symmetry operations
c               
               do i=1,syms%ntrans
                  do itype=1,crys%ntype
                     do ia=1, crys%natom(itype)
c     
c              -1
c     find mtrx    * (rat - tnp)
c
                        do l=1,3
                           cro(l) = 0.d0
                           do m=1,3
                              cro(l) = cro(l)+dble(syms%mtrx(m,l,i))*
     $                             (crys%rat(m,ia,itype)-syms%tnp(m,i
     $                             ))
                           end do
                        end do
c     
c     search for matching atom
c
                        do l=1,crys%natom(itype)
                           do m=1,3
                              xdif=abs(cro(m)-crys%rat(m,l,itype))
     $                             *ootwopi
                              idif = xdif + eps
                              if (abs(xdif-dble(idif)) .gt. eps) 
     $                             goto 16
                           end do
                           kk = l
                           goto 17
 16                        continue
                        end do
                        write(9,*) 'subroutine angular:',
     $                       'unable to find equivalent atom for k='
     $                       ,ia
                        stop
 17                     continue
c
c                       the scalar quantities can be added
c                        
                        psym(1:3,ia,itype,n,irk,is)=psym(1:3,ia,
     $                       itype,n,irk,is)+p(1:3,kk,itype,n,irk,is)
                        psym(7,ia,itype,n,irk,is)=psym(7,ia,itype,n
     $                       ,irk,is)+p(7,kk,itype,n,irk,is)

                     end do
                  end do
               end do
c
c              normalize
c
               psym(:,:,:,n,irk,is)=psym(:,:,:,n,irk,is)/
     $              dble(syms%ntrans)
               do itype=1, crys%nspin
                  do ia=1, crys%natom(itype)
                     write(9,50) is,irk,n,ia,itype,
     $                    psym(:,ia,itype,n,irk,is)
                  end do
               end do

            end do              ! loop over bands
         end do                 ! loop over kpoints
      end do                    ! loop over spins


      p=psym
      deallocate(psym)

c
c     -----------------Now compute the SLICES in  realspace ---------------
c
      if(gs(1)%myproc.eq.0) open(71,file='SLICES')

      allocate(myslab(nnz))

      do is=1, crys%nspin
         do irk=1, bands%nrk
            do n=1, bands%nband(irk,is)
c
c              fourier transform to realspace
c
               ndim = gs(irk)%length
               allocate(dhd(gs(irk)%r_size))

               call fourier_transform(-1, ffts,
     $              gs(irk),wavefn%data((n-1)*ndim+1,irk,is),dhd)
               myslab=0
               do ir=1, gs(irk)%r_size ! loop over all points
c
c                 compute the current position vector rc
c
c                 x runs fastest, then y, then z
c
                  ic=icount+ir-1  ! position in total grid
c
                  idz =(ic/(nnx*nny))

                  if((idz.ge.nnz).or.(idz.lt.0)) then 
                     write(9,*) 'BUG IN ANGULAR!'
                     call myflush(9)
                  else
                     myslab(idz+1)=myslab(idz+1)+abs(dhd(ir))**2.d0
                  endif
               end do           ! loop over all points of this wave function

               deallocate(dhd)
c
               call all_sum_all(myslab,nnz)
               if(gs(1)%myproc.eq.0) then
                  myslab=myslab*dintot
                  write(71,'(a,i4,1x,a,i4)') '#kpoint:',irk,'band:',n
                  write(71,'(i5,g16.8)') (i,myslab(i),i=1,nnz)
                  write(71,'(''&'')')
               endif

            end do              ! loop over bands
         end do                 ! loop over kpoints
      end do                    ! loop over spins

      deallocate(myslab)

      if(gs(1)%myproc.eq.0) close(71)
      if(iand(pw_params%output,8).eq.8) 
     $     write(9,110) gimmetime()-t0
      return

 50   format(i1,1x,i4,1x,i3,1x,i3,1x,i2,1x,7f9.5)
c 50   format(5i4,f12.6)
 100  format(' NUMBER OF RADIAL GRID POINTS:',i4)
 110  format(' TIME FOR ANGULAR MOMENTUM DECOMPOSITION:',f12.3)
 200  format(/' PERFORMING ANGULAR MOMENTUM DECOMPOSITION',
     $     /1x,41('-'))
      end

c
c     ====================================================================
c


      subroutine mygauleg(x1,x2,x,w,n)

      implicit none
C
C     from Numerical Recipes
C
C     .. Parameters ..
      DOUBLE PRECISION EPS
      PARAMETER (EPS=3.D-14)
C     ..
C     .. Scalar Arguments ..
      DOUBLE PRECISION X1,X2
      INTEGER N
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION W(N),X(N)
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION P1,P2,P3,PP,XL,XM,Z,Z1
      INTEGER I,J,M
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,COS
C     ..
      M = (N+1)/2
      XM = 0.5D0* (X2+X1)
      XL = 0.5D0* (X2-X1)
      DO 12 I = 1,M
          Z = COS(3.141592654D0* (I-.25D0)/ (N+.5D0))
    1     CONTINUE
          P1 = 1.0D0
          P2 = 0.0D0
          DO 11 J = 1,N
              P3 = P2
              P2 = P1
              P1 = ((2.0D0*J-1.0D0)*Z*P2- (J-1.0D0)*P3)/J
   11     CONTINUE
          PP = N* (Z*P1-P2)/ (Z*Z-1.0D0)
          Z1 = Z
          Z = Z1 - P1/PP
          IF (ABS(Z-Z1).GT.EPS) GO TO 1
          X(I) = XM - XL*Z
          X(N+1-I) = XM + XL*Z
          W(I) = 2.0D0*XL/ ((1.0D0-Z*Z)*PP*PP)
          W(N+1-I) = W(I)
   12 CONTINUE
      RETURN

      END
