
      subroutine ball_and_stick(ioutput, crys, myproc)
c
c
      include 'use.h'
      implicit none             ! implicit? Just say no!

      include 'interface.h'

c
c     --------------------------------------------------------------------
c            writes a data file for the ball and stick model
c     to be read by the appropriate module from the IBM data explorer
c     a visualization software package.
c
c    
c
c     1996 Bernd Pfrommer


c
c     INPUT
c     -----

      type (crystal) crys

      integer myproc, ioutput

c     
c     ------------- local variables
c

      integer
     $     i,j,k,ia,it, irat(3)

      double precision 
     $     pi, rat(3)

      logical ikhoros

      parameter (pi=3.141592653589793d0)
      

 
      

      if(myproc.ne.0) return    ! want only proc 0 to do this part


      if((iand(ioutput,32).ne.32).and.
     $     (iand(ioutput,16384).ne.16384)) then
         return
      endif

      call dx_latticevec(crys,myproc)
         
      ikhoros = iand(ioutput,32768).eq.32768 ! if khoros or dx

      if(ikhoros) then
         open(19,file='vis/BALLS.avs', 
     $        status='unknown',form='formatted')
      else
         open(19,file='vis/BALLS.dx', 
     $        status='unknown',form='formatted')
         write(19,10) 
      endif


c     write position array



      k=0
      do it=1, crys%ntype
         do ia=1,crys%natom(it)
            k=k+1
         end do
      end do

      if(ikhoros) then
         write(19,120) 1,3,k,1
      else
         write(19,20) k
      endif

      do it=1, crys%ntype
         do ia=1,crys%natom(it)
            rat=crys%rat(:,ia,it)/(2.d0*pi)
            if(iand(ioutput,16384).eq.16384) then !translate to first octant
               rat(:)=rat(:)+1000
               irat(:)=int(rat(:))
               rat(:)=rat(:)-dble(irat(:))
            endif
            if(ikhoros) then
               write(19,'(3f17.10,f6.1)') matmul(crys%avec,rat),dble(it)
            else
               write(19,'(3f17.10)') matmul(crys%avec,rat)
            endif
         end do
      end do

c     write the data field with the types of atoms

      if(.not.ikhoros) then
         write(19,50) k
 
         do it=1, crys%ntype
            do ia=1,crys%natom(it)
               write(19,'(f12.4)') dble(it)
            end do
         end do
         
         write(19,60)
      endif

      close(19)



      return

c
c     --------- dx formats --------------------
c
 10   format(2('#',/),'#    BALL AND STICK INFO:',i4,2(/'#'))
      
 20   format('object "ballcoord" array type float rank 1 shape 3',
     $     ' items ',i6,' data follows',/,
     $     '# the positions of the atoms')

 50   format('object "data" array type float rank 0 items',i6,
     $     ' data follows') 
 60   format(' object "molecule" field',
     $     /' component "positions" value "ballcoord"'
     $     /' component "data" value "data"',
     $     /'end')
c
c     --------- khoros formats --------------------
c
 120  format(i6/,i6/,i6/,i6)

      end



