c

      subroutine check_array(data, datasiz, 
     $     rmax, rmin,
     $     cmax, cmin,
     $     eps, ierr)
c
c     examines real and imaginary part of an array. 
c     SETS IMAGINARY PART TO ZERO!
c
c
c     1995 Bernd Pfrommer

      use all_to_all_module

      implicit none             ! never do implicit!
      include 'all_to_all.h'


c     INPUT:
c     -----

      integer 
     $     datasiz              ! number of data points in array

      complex(kind=8) 
     $     data(datasiz)        ! the data itself

      double precision
     $     eps                  ! maximum tolerated absolute value of imag

c     OUTPUT

      double precision
     $     rmax, rmin,          ! max and min value of real part of data
     $     cmax, cmin           ! max and min value of imag part of data

      integer 
     $     ierr                 ! number of data points with imag>eps
c
c     -------- local
c
      integer i
c
c
c
      rmax = dble(data(1))
      rmin = dble(data(1))
      cmax = aimag(data(1))
      cmin = aimag(data(1))
      

      ierr =0

      do i=1, datasiz
         if(dble(data(i)).gt.rmax)      rmax = dble(data(i))
         if(dble(data(i)).lt.rmin)      rmin = dble(data(i))
         if(abs(aimag(data(i))).gt.eps) ierr = ierr+1
         if(aimag(data(i)).gt.cmax)     cmax = aimag(data(i))
         if(aimag(data(i)).lt.cmin)     cmin = aimag(data(i))
         data(i)=cmplx(dble(data(i)),0.d0,kind=8) ! clear complex component
      end do

c     find max across all processors


      call all_max_all(rmax)
      call all_max_all(cmax)

      call all_min_all(rmin)
      call all_min_all(cmin)
      call all_sum_all(ierr)

      return

      end 




