C*
C*
c     @process extchk
      subroutine compute_ekin_gspace(gs, crys)

      include 'use.h'
      implicit none             ! implicit? Just say no!
      include 'interface.h'
c      INPUT:
c      ------

      type (parallel_gspace)   gs
      type (crystal)  crys
c
c     recomputes the array ekin of the gspace for the value of gs%rk.
c     assumes the ekin array is attached to the gspace, and has correct length
c     1996 Bernd Pfrommer, UC Berkeley

c
c     OUTPUT:     gs%ekin
c     ------

c
c     ------------- local variables --------------------------------------
c

      double precision qk(3)
c
c     ----- variables for the gspace loop ---------
c
      integer
     $     igv(4),fftn(4), ffth(4),igv3, irod,iord,igs

      double precision gv(3)    ! if required

c     ----------------------------------------------

      fftn(1:3)=gs%fftsize(1:3)
      fftn(4)=gs%fftsize(3)
      ffth(:)=fftn(:)/2
      igs = 0 
      do iord=1, gs%lorder    ! loop through x/y gspace 
         irod=gs%order(1,iord)
         igv(1)= irod/gs%fftsize(2)
         igv(2)= mod(irod,gs%fftsize(2))
         igv(3)= gs%order(2,iord)
         igv(4)= gs%order(3,iord)
         igv(:)= mod(igv(:)+ffth(:),fftn(:))-ffth(:) 
         gv(1:2)=dble(igv(1:2))
         do igv3=igv(3),igv(4)     ! loop over z axis
            gv(3)=dble(igv3)
            igs = igs + 1
c
c           compute kinetic energy here
c
            qk(:)=gv(:)+gs%rk(:)
            gs%ekin(igs)= (
     $           qk(1)*crys%bdot(1,1) + qk(2)*crys%bdot(2,1) +
     $           qk(3)*crys%bdot(3,1))*qk(1) +
     $           (qk(1)*crys%bdot(1,2) + qk(2)*crys%bdot(2,2) +
     $           qk(3)*crys%bdot(3,2))*qk(2) +
     $           (qk(1)*crys%bdot(1,3) + qk(2)*crys%bdot(2,3) +
     $           qk(3)*crys%bdot(3,3))*qk(3)

         end do
      end do

      return




      END

