c
      subroutine data_gather(ipr,
     $     myproc, nproc,
     $     indata, outdata,ng)

c
c     collects the array data from all procs to processor 0
c

      implicit none             ! implicit? no!

m4_ifdef([CRAY],[m4_define([MPI_INTEGER4],[MPI_INTEGER])])

m4_ifdef([MPI],[
      include 'mpif.h'])

c
c     INPUT:
c
      integer
     $     myproc, nproc, 
     $     ipr,                 ! print flag
     $     ng                   ! number of vectors in LOCAL gspace

      complex(kind=8) indata(*)  ! the local data array 
c
c     OUTPUT:
c     
      complex(kind=8) outdata(*) ! the global data array



c
c     --------- local variables ---------------------------
c
      
      integer
     $     i,j, k,info


      integer, allocatable :: recvcount(:),displs(:)

      if(nproc.gt.1) then
m4_ifdef([MPI],[

c
c        set up displs and recvcount arrays
c
         allocate(recvcount(nproc))
         allocate(displs(nproc))
         recvcount =0
         displs=0
 
         displs(myproc+1)=ng

         call mpi_allreduce(displs,recvcount,nproc,MPI_INTEGER4,MPI_SUM,
     $        MPI_COMM_WORLD,info)

         j=0
         do i=1, nproc
            displs(i)=j
            j=j+recvcount(i)
         end do
c
c        now gather everything to processor 0
c            
         call mpi_gatherv(indata,ng, MPI_DOUBLE_COMPLEX,
     $        outdata,recvcount,displs, MPI_DOUBLE_COMPLEX,
     $        0,MPI_COMM_WORLD, info)
         deallocate(recvcount)
         deallocate(displs)

])

      else
         do i=1,ng
            outdata(i)=indata(i)
         end do
      endif

c
c     now processor 0 has the global data array
c

      return

      end


