c
c
      subroutine fft_workspace(nproc, fftsize,naux,ufbs, 
     $     t1bufsize, mpistatsize)

c
c     determines size of fft workspaces for different machines
c
c     1996 Bernd Pfrommer
c
      implicit none             ! nope 

      m4_ifdef([MPI],[include 'mpif.h' ])
      
c
c     INPUT:
c     -----

      integer
     $     mpistatsize,         ! size of mpi status variable
     $     nproc,               ! number of processors
     $     fftsize(3)           ! size of the 3d fft grid

c
c     OUTPUT:
c     ------

      integer
     $     ufbs,                ! unfold buffer size
     $     t1bufsize,           ! t1 buffer size
     $     naux(4)              ! sizes of the various work arrays needed

c
c     ----------------------- local variables  -----------------------------
c     
      integer i,nmax,ix,iy

      t1bufsize = ((fftsize(1)*fftsize(3))/nproc+1) ! t1 buffer 
     $     *fftsize(2) 
      ufbs = 1

      m4_ifdef([MPI],[mpistatsize=MPI_STATUS_SIZE],
      [mpistatsize=1])
m4_ifdef([SGI_PC],[
      naux(1:3) = fftsize(1:3)+25
      naux(4)   = 1
])      
m4_ifdef([RS6K],[
      do i=1,3
         naux(i)=20000
         if(fftsize(i).gt.2048)    naux(i)=naux(i)+2.28*fftsize(i)
      end do
      naux(4)=0; nmax=0;
      do i=1,3
         if(nmax.lt.naux(i)) then
            nmax=naux(i)
            naux(4)=naux(i)+64*(2*fftsize(i)+256)
         endif
      end do
])
m4_ifdef([ALPHA],[
      naux(1:3) = 1
      naux(4)   = 1
])      
m4_ifdef([CVX],[
      naux(1:3) = (fftsize(1:3)*5)/2
      naux(4)   = 1
])      
m4_ifdef([CRAY],[
      naux(1:3) = 100 +fftsize(1:3)
c
c     this defines the maximum size of the work array for the cray ccfftm.
c
      naux(4) = 2*max((fftsize(1)*fftsize(2)/nproc +1)*fftsize(3),
     $     (fftsize(2)*fftsize(3)/nproc +1)*fftsize(1),
     $     (fftsize(1)*fftsize(3)/nproc +1)*fftsize(2))

      m4_ifdef([VECTOR],[
      ix=fftsize(1)
      iy=fftsize(2)
      if(mod(ix,2).eq.0) ix=ix+1
      if(mod(iy,2).eq.0) iy=iy+1
      ufbs = fftsize(3)*ix*iy*10
      ])

])      
m4_ifdef([SUN],[
      naux(1:3) = 4*fftsize(1:3)+15
      naux(4)   = 1
])      


      end

c
c     =====================================================================
c
c     initialize the workspace for those machines where it is
c     necessary and possible
c
c
      subroutine fft_iworkspace(workspace,naux,dim)

c     1997 Bernd Pfrommer
c
      implicit none            

c
c     INPUT:
c     -----

      integer 
     $     naux(4),             ! sizes of the fft workspace arrays
     $     dim(3)               ! fft sizes in x, y, z
c
c     OUTPUT:
c     ------

      complex(kind=8) workspace(*) ! the workspace to be initialized

c
c     ---------------------- local variables ---------------------
c
      FFT_HEADER

      integer dwx, dwy, dwz
      double precision dum

      dwx = 1
      dwy = naux(1)+1
      dwz = naux(1)+ naux(2)+1



      FFT_PERM_INIT(dim(1),workspace(dwx))
      FFT_PERM_INIT(dim(2),workspace(dwy))
      FFT_PERM_INIT(dim(3),workspace(dwz))

      end


