c
c     @process extchk opt(2)
      integer function findvec(gvec,gs)

      include 'use.h'
      implicit none             ! implicit? Just say no!
      include 'interface.h'

c
c     function searches for a vector gvec in the gspace. If successful,
c     it returns the index of gvec. If not, it returns -1
c
c     1995 Bernd Pfrommer, while at UC Berkeley
c
c     optimized Dec 26, 1995      Bernd
c     the search is best performed in the translated space
c
c
c     INPUT:
c     -----

      type (parallel_gspace)   
     $     gs                   ! the parallel gspace to search in 

      integer 
     $     gvec(3)              ! the vector to search for


c     --------------------- local variables ---------------------------

      integer i, iord, i3end, i3start, nhalf(3), irod, gv(3),
     $     iordstart,iordend, iidxstart,
     $     gvmod(3)             ! wrapped-around gvec


      findvec=-1

      nhalf(1:3) = (gs%fftsize(1:3)-1)/2

c
c     check if outside of the gspace anyways
c
      if( (gvec(1).gt.nhalf(1)).or.(gvec(1).lt.-nhalf(1))
     $     .or.(gvec(2).gt.nhalf(2)).or.(gvec(2).lt.-nhalf(2))
     $     .or.(gvec(3).gt.nhalf(3)).or.(gvec(3).lt.-nhalf(3))) 
     $     return

      gvmod(1) =mod(gvec(1)+gs%fftsize(1),gs%fftsize(1))
      gvmod(2) =mod(gvec(2)+gs%fftsize(2),gs%fftsize(2))
      gvmod(3) =mod(gvec(3)+gs%fftsize(3),gs%fftsize(3))


      iordstart = gs%fastfind(1,gvmod(1)+1)
      if(iordstart.lt.0) return
      iordend   = gs%fastfind(2,gvmod(1)+1)
      iidxstart = gs%fastfind(3,gvmod(1)+1)

      i = iidxstart
      do iord=iordstart, iordend
         i3start = gs%order(2,iord)
         i3end   = gs%order(3,iord)
         irod    = gs%order(1,iord)
         gv(1)= irod/gs%fftsize(2)
         if(gvmod(1) .eq. gv(1)) then
            gv(2)= mod(irod,gs%fftsize(2))
            if(gvmod(2) .eq. gv(2)) then
               if(i3start.gt.i3end) then
                  if((gvmod(3).le.i3end).or.(gvmod(3).ge.i3start)) then
                     findvec = i+1+mod(gvmod(3)+
     $                    gs%fftsize(3)-i3start,gs%fftsize(3))
                     return
                  endif
               else
                  if((gvmod(3).le.i3end).and.(gvmod(3).ge.i3start)) then
                     findvec = i+1+mod(gvmod(3)+
     $                    gs%fftsize(3)-i3start,gs%fftsize(3))
                     return
                  endif
               endif
            endif
         endif
         i = i + mod(i3end-i3start+gs%fftsize(3),gs%fftsize(3))+1
      end do
      
      return

      end



