c-*-Fortran-*-
c
c
      module flibcalls_module

      contains

c
c     ------------------ inversion routine -------------------------
c

      subroutine invers(mat,determinant)
      implicit none

      double precision mat(3,3), determinant
      integer ipvt(3), info
      double precision det(2), rcond, work(600)


m4_ifdef([RS6K],[
      call dgeicd(mat,3,3,2,rcond,det,work,600)

      if (det(2) .lt. -7) then 
         write(9,100)
         stop
      endif

      determinant = det(1)*10.d0**det(2)

])
m4_ifdef([SGI_PC],[
      call dgeco(mat,3,3,ipvt,rcond,work)
      if (abs(rcond) .lt. 1.d-7) then 
         write(9,100)
         stop
      endif
      call dgedi(mat,3,3,ipvt,det,work,11)
      determinant = det(1)*10.d0**det(2)

])
m4_ifdef([SUN],[
      call dgeco(mat,3,3,ipvt,rcond,work)
      if (abs(rcond) .lt. 1.d-7) then 
         write(9,100)
         stop
      endif
      call dgedi(mat,3,3,ipvt,det,work,11)
      determinant = det(1)*10.d0**det(2)

])
m4_ifdef([CRAY],[
      determinant = mat(1,1)*(mat(2,2)*mat(3,3)-mat(3,2)*mat(2,3))
     $     - mat(1,2)*(mat(2,1)*mat(3,3)-mat(3,1)*mat(2,3))
     $     + mat(1,3)*(mat(2,1)*mat(3,2)-mat(3,1)*mat(2,2))
      if(abs(determinant).lt.1.d-7) then
         write(9,100)
         stop
      endif
      call sgetrf(3,3, mat, 3, ipvt, info)
      call sgetri(3,mat,3,ipvt,work,600,info)


])
m4_ifdef([ALPHA],[
      determinant = mat(1,1)*(mat(2,2)*mat(3,3)-mat(3,2)*mat(2,3))
     $     - mat(1,2)*(mat(2,1)*mat(3,3)-mat(3,1)*mat(2,3))
     $     + mat(1,3)*(mat(2,1)*mat(3,2)-mat(3,1)*mat(2,2))
      if(abs(determinant).lt.1.d-7) then
         write(9,100)
         stop
      endif
      call dgetrf(3,3, mat, 3, ipvt, info)
      call dgetri(3,mat,3,ipvt,work,600,info)


])
m4_ifdef([CVX],[
      determinant = mat(1,1)*(mat(2,2)*mat(3,3)-mat(3,2)*mat(2,3))
     $     - mat(1,2)*(mat(2,1)*mat(3,3)-mat(3,1)*mat(2,3))
     $     + mat(1,3)*(mat(2,1)*mat(3,2)-mat(3,1)*mat(2,2))
      if(abs(determinant).lt.1.d-7) then
         write(9,100)
         stop
      endif
      call dgetrf(3,3, mat, 3, ipvt, info)
      call dgetri(3,mat,3,ipvt,work,600,info)


])
      return

 100  format('Ill conditioned matrix in invers in module flibcalls')
      end subroutine

c
c     -------------- diagonalization routine ---------------------
c
      subroutine zdiagh(n,a,lda,w,work,lwork,rwork) 

      implicit none

      character*1 jobz,uplo
      integer info, lda, lwork,n
      double precision rwork(*)
      complex(kind=8)  work
m4_ifdef([SGI_PC],[
      complex(kind=8) a
      double precision w
],[
m4_ifdef([CRAY],[
      complex(kind=8) a(:)
      double precision w(:)
],[
m4_ifdef([CVX],[
      complex(kind=8) a
      double precision w

],[
      complex(kind=8) a(lda*n)
      double precision w(n)
])
])
])
c
c     --------- local variables ----------------------------
c
      integer i,j,k
      complex(kind=8), allocatable:: dmat(:)

      uplo = 'L'
      jobz = 'V'

m4_ifdef([CRAY],[
      call cheev(jobz,uplo,n,a,lda,w,work,
     $     lwork,rwork(1),info)
],[
m4_ifdef([RS6K],[
c
c     due to a bug in the lapack routines, we must do a
c     workaround to use the ESSL library routine
c     
c
c     first pack the matrix
c
      allocate(dmat((n*(n+1))/2))

      do j=1,n
         do i=j,n
            k = i+((2*n-j)*(j-1))/2
            dmat(k)= a(i+(j-1)*lda)
         end do
      end do
      call zhpev(1,dmat(1),w(1),a(1),lda,n, work,2*lwork)
      info=0
      deallocate(dmat)

],[
      call zheev(jobz,uplo,n,a,lda,w,work,lwork,
     $       rwork(1),info)

])
])



      if(info.ne.0) write(9,110) info
      return

 110  format('Error in submatrix diagonalization:',i10)
      end subroutine

      end module
