/*
 * Macro for fortran compatibility. Modified from fftw.
 */
#ifndef _FORTRANIZE_H
#define _FORTRANIZE_H

#if defined(CRAY)
#define FORTRANIZE(x,X) X
#define C2FORTRANIZE(x,X) X 

#elif defined(SUN)
#define FORTRANIZE(x,X) x##_
#define C2FORTRANIZE(x,X) x##_ 

#elif defined(RS6K) 
#define FORTRANIZE(x,X) x
#define C2FORTRANIZE(x,X) x  

#elif defined(CVX) 
#define FORTRANIZE(x,X) x
#define C2FORTRANIZE(x,X) x

#else
/* use all lower-case with underscore by default */
#define FORTRANIZE(x,X) x##_
#define C2FORTRANIZE(x,X) x##_  

#endif



#endif /* end of if fortranize */
