c     @process extchk
c
      subroutine generate_k_gspaces(k_gspace, maxlength,
     $     pot_gspace,  kpoints, crys, syms, emax, ioutput)
c
c     
c     
      use all_to_all_module
      include 'use.h'
      implicit none             ! implicit? Just say no!
      include 'interface.h'
      include 'all_to_all.h'


c
c     INPUT:
c     -----

      integer ioutput           ! output flag
      type (crystal) crys       ! for the lattice vectors
      type (symmetry) syms
      type (fftstruc) ffts
      type (kpoint) kpoints

      double precision emax     ! energy cutoff for the wave functions!

      type(parallel_gspace)
     $     pot_gspace

c
c     OUTPUT:
c     ------
c

      type (parallel_gspace) 
     $     k_gspace(*)          ! gspace

      integer maxlength         ! maximum length of all gspaces generated

c
c     DESCRIPTION:
c     -----------

c
c     generates the small gspaces for the various kpoints
c

c
c     --------  local variables ---------------------------------
c
      integer 
     $     irk, mtrxdim, i

      
      write(9,10)

      maxlength =0
      do irk=1, kpoints%nrk
         k_gspace(irk)%gmax=sqrt(emax)
         k_gspace(irk)%rk=kpoints%rk(:,irk)
         k_gspace(irk)%nproc=pot_gspace%nproc; 
         k_gspace(irk)%myproc=pot_gspace%myproc; 
         k_gspace(irk)%name='k_gspace'
         k_gspace(irk)%fftsize=pot_gspace%fftsize;
         k_gspace(irk)%istar=.false.;k_gspace(irk)%igvec=.true.;
         k_gspace(irk)%iekin=.true.
         k_gspace(irk)%iinverse=.false.
         k_gspace(irk)%istruc=.false.
         k_gspace(irk)%ipackinfo=.true.
         
         call generate_gspace(ioutput,k_gspace(irk), crys, syms)
         if(k_gspace(irk)%length.gt.maxlength) 
     $        maxlength = k_gspace(irk)%length
         mtrxdim = k_gspace(irk)%length
         call all_sum_all(mtrxdim)
         write(9,20) irk,(kpoints%rk(i,irk),i=1,3), mtrxdim
      end do

      call myflush(9)

 10   format(/' HAMILTON MATRIX DIMENSIONS:',/1x,27('-'),
     $           /20x,'K-POINT',20x,'DIMENSION')
 20   format(i4,4x,3f10.4,12x,i6)


      end
