c
      subroutine inpmat(crys, syms)
c
      include 'use.h'
      implicit none
      include 'interface.h'


      type(crystal) crys
      type(symmetry) syms

c
c     ------------------------------------------------------
c
      integer lmtrx(48,3,3), tnp(48,3), nops, i, k,j, ierr

      double precision dummy(3,3), pi2


      pi2 = 8.d0*atan(1.d0)
c
      write(9,9000)
 9000 format(/' read transformation matrices',/1x,
     &     '(nonprimitive translations) from file:'/)
c
      open(unit=7, file='SYMMETRYOPS', status='unknown', 
     $     form='formatted')


      i=1
      nops=0

      do while(i.gt.0)
         nops=nops+1
         read(7,*,end=911) i, ((syms%mtrx(j,k,nops),k=1,3),j=1,3),
     $        (syms%tnp(k,nops),k=1,3)
         write(9,9010) nops, ((syms%mtrx(j,k,nops),k=1,3),j=1,3),
     $        (syms%tnp(k,nops),k=1,3)
 9010    format(i5,3(3x,3i3),4x,3f9.5)

      end do
 911  continue
      close(7)

      nops=nops-1


      if(nops.eq.0) then
         write(9,*) '*** SYMMETRYOPS has no symmetry operations!'
         stop
      endif

      syms%ntrans=nops

c
c     one is just the transpose of the other
c
      do k=1,3
         do j=1,3
            syms%rmtrx(k,j,:)=syms%mtrx(j,k,:)
         end do
      end do

c      do i=1, syms%ntrans
c         write(9,9013) i, syms%rmtrx(:,:,i), syms%tnp(:,i)
c      end do
c 9013 format(i5,3(3x,3i3),4x,3f8.5)

c
c     compute the realspace symmetry operations
c
      do k=1,48
         dummy = matmul(syms%rmtrx(:,:,k),transpose(crys%bvec))
         syms%rsymmat(:,:,k)=matmul(crys%avec,dummy)/pi2
      end do

c
c     transform to make symchk happy
c

      do k=1,48 
         do i=1,3
            lmtrx(k,i,:)=syms%rmtrx(i,:,k)
         end do
         tnp(k,:) = syms%tnp(:,k)
      end do 

      syms%tnp=pi2*syms%tnp

c      call symchk(0, ierr,nops,lmtrx,tnp,0)
c
      return
c
      end


