	
c
c     ===============  the primitive iolib modules ========================
c

c     The following integer markers have been used:
c
c     Int      Object:
c
c       1      gspace (not the parallel one)
c       2      isrt arrays
c       3      wave functions
c       4      kpoint
c       5      level
c       6      bands
c       7      crystal structure
c       8      symmetry info
c
c     If you add a new one, make sure you update iolib_skip() 
c     in the iolib_module
c

c     **********************************************************************
c


      module iolib_module
      contains

c
c     ======== close an iofile =============
c

      subroutine iolib_close(fname)

      implicit none


      character*(*) fname

      close(21)
c
c     ! hah ! didnot use fname at all. 
c     
      end subroutine

c
c     =============== generic routine to find certain marker =============
c

      subroutine iolib_find_marker(imark, iunit, info)

      implicit none
c
c     INPUT:
c
      integer
     $     imark,               ! integer marker
     $     iunit                ! the unit to be browsed
c
c     OUTPUT:
c
      integer info               ! 1 if marker found, 0 otherwise
c
c     ------------- local variables 
c
      integer marker, ierr
      

      rewind(iunit)

c      write(0,*) 'searching for marker:', imark

      do while (1.eq.1)
         read(iunit,*,end=100) marker
c         write(0,*) 'found marker:', marker
         if(marker.eq.imark) then ! found the right object
            info=1
            return
         else
            call iolib_skip(iunit, marker,ierr) ! found other object. skip it.
            if(ierr.ne.0) goto 100
         endif

      end do

      return

 100  continue
      
      info=0
      return

      end subroutine

c
c     ============= routine to skip an object. has to be updated ==========
c
c
c
c
      subroutine iolib_skip(iunit, imark,ierr)

      implicit none
c
c     INPUT:
c
      integer 
     $     iunit,               ! the io unit to be used
     $     imark                ! the marker code of the object to be skipped
c
c     OUTPUT:
c      
      integer ierr              ! error code. if error, then 1. Zero otherwise
c
c     ------- local variables
c
      integer i, ngtot,j,k,l

c
c     take whatever action is necessary to skip the object
c
      select case (imark)
      case default
         write(0,*) 'iolib: illegal marker: ', imark
         write(0,*) '       is the linked iolib up to date?'
         stop
      case(1) 
         read(iunit,*,err=101)  ! ------ how to skip object 1
         read(iunit,*,err=101)
         read(iunit,*,err=101)
         read(iunit,*,err=101)
         read(iunit,*,err=101)
         read(iunit,*,err=101)
         read(iunit,*,err=101)
         read(iunit,*,err=101)

         ierr=0
         return
      case(2) 
         do i=1,4               ! ------ how to skip object 2            
            read(iunit,*,err=101) 
         end do
         ierr=0
         return
      case(3) 
         do i=1,7               ! ------ how to skip object 3
            read(iunit,*,err=101) 
         end do
         ierr=0
         return
      case(4)
         do i=1,10               ! ------ how to skip object 4            
            read(iunit,*,err=101) 
         end do
         ierr=0
         return
      case(5) 
         do i=1,10              ! ------ how to skip object 5            
            read(iunit,*,err=101) 
         end do
         ierr=0
         return
      case(6) 
         do i=1,6               ! ------ how to skip object 6
            read(iunit,*,err=101) 
         end do
         ierr=0
         return
      case(7) 
         do i=1,11              ! ------ how to skip object 7
            read(iunit,*,err=101) 
         end do
         ierr=0
         return
      case(8) 
         do i=1,5              ! ------ how to skip object 8
            read(iunit,*,err=101) 
         end do
         ierr=0
         return
      end select

 101  continue
      ierr=1
      return

      end subroutine


      end module
