c
      subroutine isort_gather(ipr, mysort, gsstruct, gs)
c
c     creates global isort array
c
m4_ifdef([CRAY],[m4_define([MPI_INTEGER4],[MPI_INTEGER])])

      use vqmc_gspace_module
      include 'use.h'
      implicit none             ! implicit? no!
      include 'interface.h'

m4_ifdef([MPI],[
      include 'mpif.h'])
c
c     1996 Bernd Pfrommer
c

c
c     INPUT:
c     -----
      type (gspace) gsstruct    ! a structure containing the whole gspace


      type (parallel_gspace) gs ! the parallel gspace 

      integer
     $     ipr                  ! print flag
c
c     OUTPUT:
c     ------
      integer mysort(1:gs%length) ! the global map between data and gsstruct

c
c
c     DESCRIPTION:
c     -----------
c
c     Sets up the isort array from the parallel gspace, which
c     associates:
c
c      data(mysort(i)) <=> gstruct%gvec(:,i)
c
c
c     --------- local variables ---------------------------
c
      
      integer
     $     i,j, k, findvec,info

      external findvec

      integer, allocatable :: recvcount(:),displs(:),ibuf(:)

c
c     allocate buffer space
c

      allocate(ibuf(gs%length))

      k=0

      do i=1, gsstruct%length
         j=findvec(gsstruct%gvec(1,i),gs)
         if(j.gt.0) then
            k=k+1
            ibuf(j)=i
         endif
      end do

      if(k.ne.gs%length) then
         write(0,*) 'gspace does not enclose data completely!'
         stop
      endif

      if(gs%nproc.gt.1) then
         m4_ifdef([MPI],[
c
         write(9,*) '** WARNGING isort_gather: not debugged!'

c
c        set up displs and recvcount arrays
c
         allocate(recvcount(gs%nproc))
         allocate(displs(gs%nproc))
         recvcount =0
         displs=0

         displs(gs%myproc)=k

         call mpi_reduce(displs,recvcount,MPI_INTEGER4,MPI_SUM,0,
     $        MPI_COMM_WORLD,info)

         j=0
         do i=1, k
            displs(i)=j
            j=j+recvcount(i)
         end do
c
c        now gather everything to processor 0
c            


         call mpi_gatherv(ibuf,k, MPI_INTEGER4,
     $        mysort,recvcount,displs, MPI_INTEGER4,
     $        0,MPI_COMM_WORLD, info)
         deallocate(recvcount)
         deallocate(displs)

])

      else
         mysort(1:gs%length)=ibuf(1:gs%length)
      endif

c
c     now processor 0 has the global isort array
c


      deallocate(ibuf)

      return

      end


