c
c
c     @process extchk

      subroutine kinet(ham,xvec,neig,ekn)

      use all_to_all_module
      include 'use.h'
      implicit none             ! implicit? Just say no!
      include 'interface.h'
      include 'all_to_all.h'


c
c     calculates the kinetic energy
c     written february 18 1990. jlm
c
c     parallel fortran 90 version 1996 Bernd Pfrommer, UC Berkeley
c     
c
c     input:
c     ham         hamiltonian information
c     neig        number of eigenvectors
c     xvec(j,i)  real part of the component j of eigenvector i
c     
c     output:
c     ekn(i)      kinetic energy of eigenvector i. (rydberg)
c     
      
c     INPUT:
c     -----

      integer 
     $     neig                 ! number of eigenvectors computed

      type(hamiltonian)         ! to access the gspace and the ekinmods
     $     ham

      complex(kind=8)
     $     xvec(ham%dim,neig) ! eigenvecs as they come from diag.

c     OUTPUT:
c     ------
      
      double precision 
     $     ekn(neig)            ! kinetic energy of the bands

c     ----------- local variables ----------------------------------------


      double precision 
     $     zero, t, myderf

      external myderf

      integer
     $     i,j,len

      parameter (zero = 0.0d0)
c
c
      len = ham%gspace%length
      do i=1,neig
         ekn(i) = zero
         do j=1,len
            t = ham%gspace%ekin(j) + ham%ekinmod(1)*
     $           (1+myderf((ham%gspace%ekin(j)-ham%ekinmod(2))/
     $           ham%ekinmod(3)))
            ekn(i) = ekn(i) + t*xvec(j,i)*conjg(xvec(j,i))
         end do
      end do

      call  all_sum_all(ekn,neig)


      return

 100  format(' KINETIC ENERGY OF BANDS (RYD): ',
     $      /' -----------------------------')
 110  format(7f10.4)

      end
