c
      subroutine layout_scalapack(matsize, b, nproc, p, q)
c
c
c     INPUT:
c     -----

      integer 
     $     nproc,               ! number of processors
     $     matsize              ! size of matrix



c     OUTPUT:
c     ------

      integer 
     $     b,                   ! block size
     $     p,                   ! processor grid row
     $     q                    ! processor grid column


c
c     DESCRIPTION:
c     -----------
c
c     Figures out a  p by q processor grid layout for the scalapack
c     library. This p*q grid is used to partition the matrix with
c     a block size b. For more, see the scalapack documentation
c
c     The goal is to get a processor grid which is as close to
c     "square" as possible.
c
c     1997 Andrew Canning, Bernd Pfrommer
c

c     ----------------------- local variables ----------------------

      integer i

c
c     Find processor grid
c     

      p=int(sqrt(dble(nproc)+1d-6))

      do i=p,1,-1
         if(mod(nproc,i).eq.0) exit
      end do

      p=i

      q=nproc/p
c
c     now for the block size
c
      b = min(32, matsize/(max(p,q)))

c
c     ensure nonzero
c
      b = max(b,1)
      
      return


      end
