#ifndef TEMPLATES_LIBCALLS
#define TEMPLATES_LIBCALLS



/* -------------------- for SGI  ---------------------------- */

#ifdef SGI_PC

/*  definitions for complex C variables  */


#define REALPART re
#define IMAGPART im
#define REALPARTZ real
#define IMAGPARTZ imag
#define MACHDEP1(x) x


/* BLAS 1 calls */

#define MZAXPY(a1,a2,a3,a4,a5,a6) zaxpy(a1,a2,a3,a4,a5,a6)
#define MDAXPY(a1,a2,a3,a4,a5,a6) daxpy(a1,a2,a3,a4,a5,a6)

#define MZDSCAL(a1,a2,a3,a4) zdscal(a1,a2,a3,a4)
#define MDSCAL(a1,a2,a3,a4) dscal(a1,a2,a3,a4)

#define MDDOT(a0,a1,a2,a3,a4,a5) {a0=ddot(a1,a2,a3,a4,a5);}
#define MDNRM2(a0,a1,a2,a3) {a0=dnrm2(a1,a2,a3);}

#define MDCOPY(a1,a2,a3,a4,a5) dcopy(a1,a2,a3,a4,a5)
#define MZCOPY(a1,a2,a3,a4,a5) zcopy(a1,a2,a3,a4,a5)

/* BLAS 3 calls */

#define MZGEMM(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2,b3) zgemm(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2,b3)
#define MZHERK(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) zherk(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) 
#define MZHER2K(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2) zher2k(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2) 


/* Matrix inversion */

#define DGECO(a1,a2,a3,a4,a5,a6) {dgeco_(a1,a2,a3,a4,a5,a6);}
#define DGEDI(a1,a2,a3,a4,a5,a6,a7) {dgedi_(a1,a2,a3,a4,a5,a6,a7);}

/* Eigenvalues */

#define DSYEV dsyev_

/* include files */

#include <cblas.h>
#include <fft.h>

#define ZOMPLEX Zomplex

#endif




#ifdef RS6K

/*  definitions for complex C variables  */

#define zomplex dcmplx
#define Zomplex dcmplx

#define ConjugateTranspose "C"
#define NoTranspose "N"
#define Transpose "T"
#define LowerTriangle "L"
#define UpperTriangle "U"

#define REALPART __data.__re
#define IMAGPART __data.__im
#define REALPARTZ __data.__re
#define IMAGPARTZ __data.__im
#define MACHDEP1(x) x.__data.__re


/* BLAS 1 calls */

#define MZAXPY(a1,a2,a3,a4,a5,a6) zaxpy(a1,a2,a3,a4,a5,a6)
#define MDAXPY(a1,a2,a3,a4,a5,a6) daxpy(a1,a2,a3,a4,a5,a6)

#define MZDSCAL(a1,a2,a3,a4) zdscal(a1,a2,a3,a4)
#define MDSCAL(a1,a2,a3,a4) dscal(a1,a2,a3,a4)

#define MDDOT(a0,a1,a2,a3,a4,a5) {a0=ddot(a1,a2,a3,a4,a5);}
#define MDNRM2(a0,a1,a2,a3) {a0=dnrm2(a1,a2,a3);}

#define MDCOPY(a1,a2,a3,a4,a5) dcopy(a1,a2,a3,a4,a5)
#define MZCOPY(a1,a2,a3,a4,a5) zcopy(a1,a2,a3,a4,a5)

/* BLAS 3 calls */

#define MZGEMM(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2,b3) zgemm(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2,b3)
#define MZHERK(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) zherk(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) 
#define MZHER2K(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2) zher2k(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2) 


/* Matrix inversion */

#define DGECO(a1,a2,a3,a4,a5,a6) {dgeco_(a1,a2,a3,a4,a5,a6);}
#define DGEDI(a1,a2,a3,a4,a5,a6,a7) {dgedi_(a1,a2,a3,a4,a5,a6,a7);}

/* Eigenvalues */

#define DSYEV dsyev
#define zheev_ zheev

/* include files */

#include <essl.h>
#include <time.h>
#define ZOMPLEX zomplex

#endif




/* --------------------     for the Convex    -------------------------- */

/*   everything is passed by reference, since the fortran libs are linked */

#ifdef CVX
int MY_DUM1, MY_DUM2, MY_DUM3, 
        MY_DUM4, MY_DUM5, MY_DUM6;
double  MY_DDUM1;

/*  definitions for complex C variables  */

typedef struct {
    float re;
    float im;
} complex;

typedef struct {
    double real;
    double imag;
} zomplex;

typedef zomplex Zomplex;

#define REALPART real
#define IMAGPART imag
#define REALPARTZ real
#define IMAGPARTZ imag
#define MACHDEP1(x) x
#define ConjugateTranspose "C"
#define NoTranspose "N"
#define Transpose "T"
#define LowerTriangle "L"
#define UpperTriangle "U"


/* BLAS 1 calls */


#define MZAXPY(a1,a2,a3,a4,a5,a6) {MY_DUM1=a1;MY_DUM2=a4; MY_DUM3=a6; zaxpy(&MY_DUM1,(complex16_t*)&(a2),(complex16_t*)(a3),&MY_DUM2,(complex16_t*)(a5),&MY_DUM3);}
#define MDAXPY(a1,a2,a3,a4,a5,a6) {MY_DDUM1=a2; MY_DUM1=a1;MY_DUM2=a4; MY_DUM3=a6; daxpy_(&MY_DUM1,&MY_DDUM1,a3,&MY_DUM2,a5,&MY_DUM3);}

#define MZDSCAL(a1,a2,a3,a4) {MY_DDUM1=a2;MY_DUM1=a1;MY_DUM2=a4; zdscal_(&MY_DUM1,&MY_DDUM1,(complex16_t*)(a3),&MY_DUM2);}
#define MDSCAL(a1,a2,a3,a4) {MY_DDUM1=a2;MY_DUM1=a1;MY_DUM2=a4; dscal_(&MY_DUM1,&MY_DDUM1,a3,&MY_DUM2);}

double ddot_(int*, double *, int*, double*, int*);
#define MDDOT(a0,a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3; MY_DUM3=a5; a0=ddot_(&MY_DUM1,a2,&MY_DUM2,a4,&MY_DUM3);}

double dnrm2_(int*, double*, int*);
#define MDNRM2(a0,a1,a2,a3) {MY_DUM1=a1;MY_DUM3=a3; a0=dnrm2_(&MY_DUM1,a2,&MY_DUM3);}

#define MDCOPY(a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3;MY_DUM3=a5;dcopy_(&MY_DUM1,a2,&MY_DUM2,a4,&MY_DUM3);}

#define MZCOPY(a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3;MY_DUM3=a5;zcopy_(&MY_DUM1,(void *)a2,&MY_DUM2,(void *)a4,&MY_DUM3);}



/* BLAS 3 calls */


#define MZGEMM(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2,b3) {MY_DUM1=a3;MY_DUM2=a4; MY_DUM3=a5; MY_DUM4=a8;MY_DUM5=b0; MY_DUM6=b3; zgemm(a1,a2,&MY_DUM1,&MY_DUM2,&MY_DUM3,(complex16_t*) &a6,(complex16_t*)a7, &MY_DUM4,(complex16_t*) a9, &MY_DUM5,(complex16_t*)&b1,(complex16_t*)b2,&MY_DUM6,1,1);}

#define MZHERK(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) {MY_DUM1=a3;MY_DUM2=a4;MY_DUM3=a7;MY_DUM4=b0; zherk(a1,a2, &MY_DUM1, &MY_DUM2,(double *)&(a5),(complex16_t*)(a6),&MY_DUM3,(double *)&(a8),(complex16_t *)(a9),&MY_DUM4,1,1);}

#define MZHER2K(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2) {MY_DUM1=a3;MY_DUM2=a4;MY_DUM3=a7;MY_DUM4=a9; MY_DUM5=b2; zher2k(a1,a2, &MY_DUM1, &MY_DUM2,(double *)&(a5),(complex16_t*)(a6),&MY_DUM3,(complex16_t*)(a8),&MY_DUM4, (double *)&(b0),(complex16_t*)(b1),&MY_DUM5,1,1);}

#define zheev_(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) {zheev_(a1,a2,a3,(complex16_t*)(a4),a5,a6,(complex16_t*)(a7),a8,(double *)a9,b0,1,1);}


/* Matrix inversion */

#define DGECO(a1,a2,a3,a4,a5,a6) {dgeco_(a1,a2,a3,a4,a5,a6);}
#define DGEDI(a1,a2,a3,a4,a5,a6,a7) {dgedi_(a1,a2,a3,a4,a5,a6,a7);}


/* Eigenvalues */


#define DSYEV dsyev

/* include files */
#define ZOMPLEX zomplex

#endif


/* --------------------------- for the CRAY ------------------------- */

#ifdef CRAY
int MY_DUM1, MY_DUM2, MY_DUM3, 
        MY_DUM4, MY_DUM5, MY_DUM6;
double  MY_DDUM1;

/* complex variable type definitons */

typedef struct {
    float re;
    float im;
} complex;

typedef struct {
    double real;
    double imag;
} zomplex;

typedef zomplex Zomplex;

#define REALPART real
#define IMAGPART imag
#define REALPARTZ real
#define IMAGPARTZ imag
#define MACHDEP1(x) x
#define ConjugateTranspose "C"
#define NoTranspose "N"
#define Transpose "T"
#define LowerTriangle "L"
#define UpperTriangle "U"



/* BLAS 1 calls */


#define MZAXPY(a1,a2,a3,a4,a5,a6) {MY_DUM1=a1;MY_DUM2=a4; MY_DUM3=a6; CAXPY(&MY_DUM1,(Zomplex*)&(a2),(Zomplex*)(a3),&MY_DUM2,(Zomplex*)(a5),&MY_DUM3);}
#define MDAXPY(a1,a2,a3,a4,a5,a6) {MY_DDUM1=a2; MY_DUM1=a1;MY_DUM2=a4; MY_DUM3=a6; SAXPY(&MY_DUM1,&MY_DDUM1,a3,&MY_DUM2,a5,&MY_DUM3);}

#define MZDSCAL(a1,a2,a3,a4) {MY_DDUM1=a2;MY_DUM1=a1;MY_DUM2=a4; CSSCAL(&MY_DUM1,&MY_DDUM1,(Zomplex*)(a3),&MY_DUM2);}
#define MDSCAL(a1,a2,a3,a4) {MY_DDUM1=a2;MY_DUM1=a1;MY_DUM2=a4; SSCAL(&MY_DUM1,&MY_DDUM1,a3,&MY_DUM2);}

double SDOT(int*, double *, int*, double*, int*);
#define MDDOT(a0,a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3; MY_DUM3=a5; a0=SDOT(&MY_DUM1,a2,&MY_DUM2,a4,&MY_DUM3);}

double SNRM2(int*, double*, int*);
#define MDNRM2(a0,a1,a2,a3) {MY_DUM1=a1;MY_DUM3=a3; a0=SNRM2(&MY_DUM1,a2,&MY_DUM3);}

#define MDCOPY(a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3;MY_DUM3=a5;SCOPY(&MY_DUM1,a2,&MY_DUM2,a4,&MY_DUM3);}

#define MZCOPY(a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3;MY_DUM3=a5;CCOPY(&MY_DUM1,(Zomplex *)a2,&MY_DUM2,(Zomplex *)a4,&MY_DUM3);}



/* BLAS 3 calls */


#define MZGEMM(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2,b3) {MY_DUM1=a3;MY_DUM2=a4; MY_DUM3=a5; MY_DUM4=a8;MY_DUM5=b0; MY_DUM6=b3; CGEMM(a1,a2,&MY_DUM1,&MY_DUM2,&MY_DUM3,(Zomplex*) &a6,(Zomplex*)a7, &MY_DUM4,(Zomplex*) a9, &MY_DUM5,(Zomplex*)&b1,(Zomplex*)b2,&MY_DUM6,1,1);}

#define MZHERK(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) {MY_DUM1=a3;MY_DUM2=a4;MY_DUM3=a7;MY_DUM4=b0; CHERK(a1,a2, &MY_DUM1, &MY_DUM2,(double *)&(a5),(Zomplex*)(a6),&MY_DUM3,(double *)&(a8),(Zomplex *)(a9),&MY_DUM4,1,1);}

#define MZHER2K(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2) {MY_DUM1=a3;MY_DUM2=a4;MY_DUM3=a7;MY_DUM4=a9; MY_DUM5=b2; CHER2K(a1,a2, &MY_DUM1, &MY_DUM2,(double *)&(a5),(Zomplex*)(a6),&MY_DUM3,(Zomplex*)(a8),&MY_DUM4, (double *)&(b0),(Zomplex*)(b1),&MY_DUM5,1,1);}

#define zheev_(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) {CHEEV(a1,a2,a3,(Zomplex*)(a4),a5,a6,(Zomplex*)(a7),a8,(double *)a9,b0,1,1);}


/* Matrix inversion (not used any more)*/

#define DGECO(a1,a2,a3,a4,a5,a6) {SGECO(a1,a2,a3,a4,a5,a6);}
#define DGEDI(a1,a2,a3,a4,a5,a6,a7) {SGEDI(a1,a2,a3,a4,a5,a6,a7);}


/* Eigenvalues */


#define DSYEV SSYEV

/* define trailing underscore for c to fortran calls */

#define ZOMPLEX zomplex
#endif


/* --------------------------- for the ALPHA ------------------------- */

#ifdef ALPHA
int MY_DUM1, MY_DUM2, MY_DUM3, 
        MY_DUM4, MY_DUM5, MY_DUM6;
double  MY_DDUM1;

/* complex variable type definitons */

typedef struct {
    float re;
    float im;
} complex;

typedef struct {
    double real;
    double imag;
} zomplex;

typedef zomplex Zomplex;

#define REALPART real
#define IMAGPART imag
#define REALPARTZ real
#define IMAGPARTZ imag
#define MACHDEP1(x) x
#define ConjugateTranspose "C"
#define NoTranspose "N"
#define Transpose "T"
#define LowerTriangle "L"
#define UpperTriangle "U"

/* BLAS 1 calls */


#define MZAXPY(a1,a2,a3,a4,a5,a6) {MY_DUM1=a1;MY_DUM2=a4; MY_DUM3=a6; CAXPY(&MY_DUM1,(Zomplex*)&(a2),(Zomplex*)(a3),&MY_DUM2,(Zomplex*)(a5),&MY_DUM3);}
#define MDAXPY(a1,a2,a3,a4,a5,a6) {MY_DDUM1=a2; MY_DUM1=a1;MY_DUM2=a4; MY_DUM3=a6; daxpy_(&MY_DUM1,&MY_DDUM1,a3,&MY_DUM2,a5,&MY_DUM3);}

#define MZDSCAL(a1,a2,a3,a4) {MY_DDUM1=a2;MY_DUM1=a1;MY_DUM2=a4; zdscal_(&MY_DUM1,&MY_DDUM1,(Zomplex*)(a3),&MY_DUM2);}
#define MDSCAL(a1,a2,a3,a4) {MY_DDUM1=a2;MY_DUM1=a1;MY_DUM2=a4; dscal_(&MY_DUM1,&MY_DDUM1,a3,&MY_DUM2);}

double ddot_(int*, double *, int*, double*, int*);
#define MDDOT(a0,a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3; MY_DUM3=a5; a0=ddot_(&MY_DUM1,a2,&MY_DUM2,a4,&MY_DUM3);}

double dnrm2_(int*, double*, int*);
#define MDNRM2(a0,a1,a2,a3) {MY_DUM1=a1;MY_DUM3=a3; a0=dnrm2_(&MY_DUM1,a2,&MY_DUM3);}

#define MDCOPY(a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3;MY_DUM3=a5;dcopy_(&MY_DUM1,a2,&MY_DUM2,a4,&MY_DUM3);}

#define MZCOPY(a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3;MY_DUM3=a5;zcopy_(&MY_DUM1,(Zomplex *)a2,&MY_DUM2,(Zomplex *)a4,&MY_DUM3);}



/* BLAS 3 calls */


#define MZGEMM(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2,b3) {MY_DUM1=a3;MY_DUM2=a4; MY_DUM3=a5; MY_DUM4=a8;MY_DUM5=b0; MY_DUM6=b3; zgemm_(a1,a2,&MY_DUM1,&MY_DUM2,&MY_DUM3,(Zomplex*) &a6,(Zomplex*)a7, &MY_DUM4,(Zomplex*) a9, &MY_DUM5,(Zomplex*)&b1,(Zomplex*)b2,&MY_DUM6,1,1);}

#define MZHERK(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) {MY_DUM1=a3;MY_DUM2=a4;MY_DUM3=a7;MY_DUM4=b0; zherk_(a1,a2, &MY_DUM1, &MY_DUM2,(double *)&(a5),(Zomplex*)(a6),&MY_DUM3,(double *)&(a8),(Zomplex *)(a9),&MY_DUM4,1,1);}

#define MZHER2K(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2) {MY_DUM1=a3;MY_DUM2=a4;MY_DUM3=a7;MY_DUM4=a9; MY_DUM5=b2; zher2k_(a1,a2, &MY_DUM1, &MY_DUM2,(double *)&(a5),(Zomplex*)(a6),&MY_DUM3,(Zomplex*)(a8),&MY_DUM4, (double *)&(b0),(Zomplex*)(b1),&MY_DUM5,1,1);}

#define zheev_(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) {zheev_(a1,a2,a3,(Zomplex*)(a4),a5,a6,(Zomplex*)(a7),a8,(double *)a9,b0,1,1);}

/* Eigenvalues */


#define DSYEV dsyev_

#define ZOMPLEX zomplex

#endif


/* -------------------- for SUN  ---------------------------- */

#ifdef SUN
int MY_DUM1, MY_DUM2, MY_DUM3, 
        MY_DUM4, MY_DUM5, MY_DUM6;
double  MY_DDUM1;

/* complex variable type definitons */

typedef struct {
    float re;
    float im;
} complex;

typedef struct {
    double real;
    double imag;
} zomplex;

typedef zomplex Zomplex;

#define REALPART real
#define IMAGPART imag
#define REALPARTZ real
#define IMAGPARTZ imag
#define MACHDEP1(x) x
#define ConjugateTranspose "C"
#define NoTranspose "N"
#define Transpose "T"
#define LowerTriangle "L"
#define UpperTriangle "U"

/* BLAS 1 calls */


#define MZAXPY(a1,a2,a3,a4,a5,a6) {MY_DUM1=a1;MY_DUM2=a4; MY_DUM3=a6; CAXPY(&MY_DUM1,(Zomplex*)&(a2),(Zomplex*)(a3),&MY_DUM2,(Zomplex*)(a5),&MY_DUM3);}
#define MDAXPY(a1,a2,a3,a4,a5,a6) {MY_DDUM1=a2; MY_DUM1=a1;MY_DUM2=a4; MY_DUM3=a6; daxpy_(&MY_DUM1,&MY_DDUM1,a3,&MY_DUM2,a5,&MY_DUM3);}

#define MZDSCAL(a1,a2,a3,a4) {MY_DDUM1=a2;MY_DUM1=a1;MY_DUM2=a4; zdscal_(&MY_DUM1,&MY_DDUM1,(Zomplex*)(a3),&MY_DUM2);}
#define MDSCAL(a1,a2,a3,a4) {MY_DDUM1=a2;MY_DUM1=a1;MY_DUM2=a4; dscal_(&MY_DUM1,&MY_DDUM1,a3,&MY_DUM2);}

double ddot_(int*, double *, int*, double*, int*);
#define MDDOT(a0,a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3; MY_DUM3=a5; a0=ddot_(&MY_DUM1,a2,&MY_DUM2,a4,&MY_DUM3);}

double dnrm2_(int*, double*, int*);
#define MDNRM2(a0,a1,a2,a3) {MY_DUM1=a1;MY_DUM3=a3; a0=dnrm2_(&MY_DUM1,a2,&MY_DUM3);}

#define MDCOPY(a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3;MY_DUM3=a5;dcopy_(&MY_DUM1,a2,&MY_DUM2,a4,&MY_DUM3);}

#define MZCOPY(a1,a2,a3,a4,a5) {MY_DUM1=a1;MY_DUM2=a3;MY_DUM3=a5;zcopy_(&MY_DUM1,(Zomplex *)a2,&MY_DUM2,(Zomplex *)a4,&MY_DUM3);}



/* BLAS 3 calls */


#define MZGEMM(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2,b3) {MY_DUM1=a3;MY_DUM2=a4; MY_DUM3=a5; MY_DUM4=a8;MY_DUM5=b0; MY_DUM6=b3; zgemm_(a1,a2,&MY_DUM1,&MY_DUM2,&MY_DUM3,(Zomplex*) &a6,(Zomplex*)a7, &MY_DUM4,(Zomplex*) a9, &MY_DUM5,(Zomplex*)&b1,(Zomplex*)b2,&MY_DUM6,1,1);}

#define MZHERK(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) {MY_DUM1=a3;MY_DUM2=a4;MY_DUM3=a7;MY_DUM4=b0; zherk_(a1,a2, &MY_DUM1, &MY_DUM2,(double *)&(a5),(Zomplex*)(a6),&MY_DUM3,(double *)&(a8),(Zomplex *)(a9),&MY_DUM4,1,1);}

#define MZHER2K(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0,b1,b2) {MY_DUM1=a3;MY_DUM2=a4;MY_DUM3=a7;MY_DUM4=a9; MY_DUM5=b2; zher2k_(a1,a2, &MY_DUM1, &MY_DUM2,(double *)&(a5),(Zomplex*)(a6),&MY_DUM3,(Zomplex*)(a8),&MY_DUM4, (double *)&(b0),(Zomplex*)(b1),&MY_DUM5,1,1);}

#define zheev_(a1,a2,a3,a4,a5,a6,a7,a8,a9,b0) {zheev_(a1,a2,a3,(Zomplex*)(a4),a5,a6,(Zomplex*)(a7),a8,(double *)a9,b0,1,1);}

/* Eigenvalues */


#define DSYEV dsyev_

/* Matrix inversion */

#define DGECO(a1,a2,a3,a4,a5,a6) {dgeco_(a1,a2,a3,a4,a5,a6);}
#define DGEDI(a1,a2,a3,a4,a5,a6,a7) {dgedi_(a1,a2,a3,a4,a5,a6,a7);}


#define ZOMPLEX zomplex

#endif






#endif        /* template */
