c
c     @process extchk
      subroutine neighbor(crys, pw_params)

c
c     find the nearest neighbor distances and other information
c
c

c     1996 by Bernd Pfrommer, while at UCB

      include 'use.h'
      implicit none             ! implicit? Just say no!
      include 'interface.h'

c     INPUT:
c     -----

      type (crystal) crys
      type (pw_parameter) pw_params


c
c     ---------- local variables ---------------------
c

      double precision
     $     rc(3), rc1(3), pi2, drc(3),d,d2,del, dr(3), dum,
     $     alld(2,crys%mxdatm*crys%ntype), 
     $     angl(crys%mxdatm*crys%ntype),
     $     alldr(3,crys%mxdatm*crys%ntype,crys%mxdatm*crys%ntype) 


      integer
     $     indx(crys%mxdatm*crys%ntype),
     $     nt,ia, nt1,ia1, i, j,k,i1,i2,i3,iv(3),nn, nn0,nn1

      character*255 fmtstr

      pi2 = 8.d0* datan(1.d0)


      if((iand(pw_params%output,64).ne.64).and.
     $     (iand(pw_params%output,8192).ne.8192)) return
c
c     count number of atoms
c
      nn0 = 0
      do nt=1,crys%ntype
         do ia=1, crys%natom(nt)
            nn0=nn0+1
         end do
      end do

      if(iand(pw_params%output,64).eq.64) then
         write(9,10)
         write(9,20) ((crys%nameat(nt),j,j=1,crys%natom(nt)),
     $        nt=1,crys%ntype)
         write(fmtstr,24) nn0
         write(9,fmtstr) (j,j=1,nn0)
      endif

      alldr=0

      nn0=0
      do nt=1,crys%ntype
         do ia=1, crys%natom(nt)
            nn0=nn0+1
            rc = crys%rat(:,ia,nt)/pi2
c
c           make sure it is in first unit cell
c
            rc(:) = mod(rc(:)+1.d0,1.d0)
            rc = matmul(crys%avec,rc)
c
c           now check for neighbors
c
            nn=0
            nn1=0
            do nt1=1,crys%ntype
               do ia1=1, crys%natom(nt1)
                  nn1=nn1+1
                  nn=nn+1
                  d=1e6
                  d2=1e6
                  do i1=-1,1 ;do i2=-1,1 ;do i3=-1,1
                     iv(1)=i1 ; iv(2)=i2 ; iv(3)=i3
                     rc1 = crys%rat(:,ia1,nt1)/pi2
                     rc1(:) = mod(rc1(:)+1.d0,1.d0)
                     rc1 = matmul(crys%avec,dble(iv)+rc1)
c     write(9,*) 'rc test=',rc1
                     drc=rc1-rc
c     write(9,*) 'deltarc=',drc
                     del = sqrt(drc(1)*drc(1)+drc(2)*drc(2)+
     $                    drc(3)*drc(3))
                     if((del.lt.d-1d-6).and.(del.gt.1d-6)) then
                        d2=d    
                        d=del   ! found nearest neighbor
                        dr=drc
                     elseif((del.lt.d2).and.(del.gt.1d-6).and.
     $                       (del.gt.d+1d-6)) then
                        d2=del  ! found 2nd nearest neighbor
                     endif
                  end do ; end do; end do;
                  alld(1,nn)=d
                  alld(2,nn)=d2
                  alldr(:,nn,nn0)=dr
               end do
            end do
            if(iand(pw_params%output,64).eq.64) then
               write(9,100) crys%nameat(nt), ia,crys%rat(:,ia,nt)/pi2
     $              ,(alld(1,i),i=1,nn)
               write(9,110) nn0,(alld(2,i),i=1,nn)
c
c              compute ordered list of neighbors
c               
               do i=1,nn
                  indx(i)=i
               end do
               call sort(nn,alld(1,:),indx)
               write(9,115) (indx(i),alld(1,indx(i)),i=1,nn)

            endif
         end do
      end do
c
c     -------------- compute and print the angles ------------
c
      if(iand(pw_params%output,8192).eq.8192) then
         write(9,12)

         do i=1,nn0
            write(9,30) i
            do j=1,nn0
               do k=1,j
                  dr  = alldr(:,j,i)
                  del = sqrt(dot_product(dr,dr))
                  drc = alldr(:,k,i)
                  d   = sqrt(dot_product(drc,drc))
                  if((del.gt.1d-6).and.(d.gt.1d-6)) then
                     dum = dot_product(dr,drc)/del/d
                     if(dum.gt.1.d0) dum=1.d0
                     if(dum.lt.-1.d0) dum=-1.d0
                     angl(k) = 180.d0 / 3.14159265*
     $                    acos(dum)
                  else
                     angl(k)=0
                  endif
               end do
               write(9,40) j,(angl(k), k=1,j)
            end do
         end do
      endif

      call myflush(9)

 10   format(/1x,20('-'),' NEIGHBOR INFORMATION ',20('-'))
 12   format(/1x,20('-'),'  ANGLE   INFORMATION ',20('-'))
 20   format(/2x,'ATOM',12x,'COORD',9x,1000(5x,a4,i3))
 22   format(2x,'(NR)',12x,'     ',9x,1000(6x,'(',i3,')',1x)/)
 24   format('(2x,''(NR)'',12x,''     '',9x,',
     $     i5,'(6x,''('',i3,'')'',1x)/)')
 30   format(/' %%%%%%% BOND CENTER: ATOM ',i3,' %%%%%%%%%')
 40   format(i3,1000f7.2)
 100  format(1x,a2,i3,3f9.4,'|', 500f12.6)
 110  format(1x,'(',i3,')',27x,'|', 500f12.6)
 115  format(33x,'|', 500(i4,'(',f6.3,')'))


      end
