c
      subroutine print_pwparam(ipr,pw)

c
c     prints out information about the gspace
c
c     (1996) Bernd Pfrommer
c

      include 'use.h'
      implicit none             ! never
      include 'interface.h'


c
c     INPUT:
c     ------

      integer ipr               ! print level flag
      type (pw_parameter) pw ! the gspace to be printed out

c
c     ----------   local variables  --------------------------
c
      integer i,j,k

      if(ipr.gt.0) then      
         if(pw%icorr.eq.'ca') write(9,90)
         if(pw%icorr.eq.'g1') write(9,92)
         
         write(9,106) pw%emax
         write(9,107) pw%emaxmix
         write(9,110) pw%epscv
         write(9,122) pw%shiftsafety
         write(9,124) pw%epsdiag
         write(9,120) pw%smearing
         if(pw%ekinmod(1).gt.0.0)  
     $        write(9,108) pw%ekinmod(1),pw%ekinmod(2),pw%ekinmod(3)
         if(pw%random_startvec.gt.0.0)  
     $        write(9,115) pw%random_startvec

         if(pw%mfield%gvec(4).ne.0) then
            write(9,550) pw%mfield%gvec(1),pw%mfield%gvec(2),
     $           pw%mfield%gvec(3),pw%mfield%h
         endif
         if(pw%epot%gvec(4).ne.0) then
            write(9,560) pw%epot%gvec(1:3), pw%epot%h
         endif

         if(iand(pw%optimize,1).eq.1) write(9,200)
         if(iand(pw%optimize,2).eq.2) write(9,201)
         if(iand(pw%optimize,4).eq.4) write(9,202)
         if(iand(pw%optimize,8).eq.8) write(9,203)
         if(iand(pw%optimize,16).ne.16) write(9,204)
         if(iand(pw%optimize,32).ne.32) write(9,205)
         if(iand(pw%optimize,64).eq.64) write(9,206)

         if(iand(pw%miscflag,1).eq.1) write(9,215)
     $        'NO RESTORE INVERSION'
         if(iand(pw%miscflag,2).eq.2) write(9,215) 
     $        'CHECKPOINT NMR'
         if(pw%checkpoint_wfn.lt.1000000) 
     $        write(9,230) pw%checkpoint_wfn

         if(iand(pw%input,1).eq.1) write(9,220) 'WAVEFN'
         if(iand(pw%input,2).eq.2) write(9,220) 'LUKMAN'
         if(iand(pw%input,4).eq.4) write(9,220) 'CHKPTCHI'

         if(iand(pw%output,1).eq.1) write(9,210) 'DIAGPERF'
         if(iand(pw%output,2).eq.2) write(9,210) 'VQMC'
         if(iand(pw%output,4).eq.4) write(9,210) 'NMRSHIFT'
         if(iand(pw%output,8).eq.8) write(9,210) 'TIMING'
         if(iand(pw%output,16).eq.16) write(9,210) 'CDPLOT'
         if(iand(pw%output,32).eq.32) write(9,210) 'BALLNSTICK'
         if(iand(pw%output,64).eq.64) write(9,210) 'NEIGHBORS'
         if(iand(pw%output,128).eq.128) write(9,210) 'DOS'
         if(iand(pw%output,256).eq.256) write(9,210) 'WAVEPLOT'
         if(iand(pw%output,512).eq.512) write(9,210) 'WAVEFN'
         if(iand(pw%output,1024).eq.1024) write(9,210) 'ANGDOS'
         if(iand(pw%output,2048).eq.2048) write(9,210) 'EIGVAL'
         if(iand(pw%output,4096).eq.2048) write(9,210) 'MOMDENS'
         if(iand(pw%output,8192).eq.8192) write(9,210) 'ANGLES'
         if(iand(pw%output,16384).eq.16384) write(9,210)
     $        'BALLSWRAPPED'
         if(iand(pw%output,32768).eq.32768) write(9,210) 'KHOROS'
         if(iand(pw%output,65536).eq.65536) write(9,210) 'MEMUSAGE'
      endif

      call myflush(9)

 90   FORMAT(/,' EXCHANGE-CORRELATION: CEPERLEY-ALDER')
 92   FORMAT(/,' EXCHANGE-CORRELATION: PERDEW-WANG 91')
 100  FORMAT(2X,10F8.4)
 106  FORMAT(/,' ENERGY CUTOFF EMAX               = ',F12.6)
 107  format(  ' BROYDEN MIXING CUTOFF            = ',F12.6)
 108  format(/,' MODIFIED KINETIC ENERGY: A = ',F9.4,
     $     ', E0 = ',F9.4,', SIGMA = ',F9.4)
 110  format(  ' POTENTIAL CONVERGENCE CRITERION  = ',g12.6)
 115  format(  ' RANDOM DIAGONALIZATION STARTING  = ',g12.6)
 122  format(  ' SAFETY FOR DIAGONALIZATION       = ',f12.6) 
 124  format(  ' DIAGONALIZATION ACCURACY         = ',g12.6) 
 120  format(  ' GAUSSIAN SMEARING PARAMETER [eV] = ',f12.6) 

 200  format(' OPTIMIZING FOR MEMORY USAGE')
 201  format(' OPTIMIZING STARTING GUESS IN NMR CALCULATION')
 202  format(' OPTIMIZING CGSOLVEGUESS IN NMR CALCULATION')
 203  format(' OPTIMIZING FOR INSULATOR (DIRECT ENERGY MINIMIZATION)')
 204  format(' NOT REUSING THE WAVE FUNCTION FROM PREVIOUS RELAXATION')
 205  format(' PRECONDITIONING SWITCHED OFF! WANT A PERFORMANCE HIT?')
 206  format(' OPTIMIZING FOR METAL (DIRECT ENERGY MINIMIZATION)')

 210  format(' ADDITIONAL OUTPUT: ',a)
 215  format(' MISC FLAG: ',a)
 220  format(' ADDITIONAL INPUT: ',a)
 230  format(' DIRECT EMIN CHECKPOINTING WAVE FUNCTION EVERY',
     $     i4,' STEPS')

 550  format(' MAGNETIC FIELD WITH G= ',3i3,' AND STRENGTH ',f12.6)
 560  format(' ELECTRIC POTENTIAL WITH G= ',3i3,' AND STRENGTH ',f12.6)

      end
