c
      subroutine randomize_startguess(crys, gs, gsub,
     $     random_startvec, neig, xvec)

      include 'use.h'
      use all_to_all_module
      implicit none             ! implicit? Just say no!
      include 'interface.h'
      include 'all_to_all.h'
c
c
c     INPUT:
c     -----
c      
      type(crystal) crys

      type(parallel_gspace) gs
      
      double precision 
     $     random_startvec,     ! percent of random components
     $     gsub                 ! sub gspace gmax

      integer 
     $     neig                 ! number of eigenvectors

c
c     INPUT/OUTPUT:
c     ------------

      complex(kind=8) 
     $     xvec(gs%length*neig) ! the wave functions without/with random comp.

c
c     1997 Michel Cote, Bernd Pfrommer
c
c     
c     DESCRIPTION:
c     -----------
c
c     Throws in random components into the starting guess. This is
c     only done for those gvectors that are outsided the starting 
c     guess energy cutoff, and would be zero otherwise. 
c

c
c
c     ---------------------- local variables ------------------------
c
      double precision 
     $     gm, a, temp_norm, temp, temp2, prefac, pi2, dsqtemp 

      complex(kind=8) random

      integer 
     $     l,j


      pi2 = 8*atan(1.0)


      gm=gs%gmax
      a=1.d0/1d0                ! one over the decay length in a.u.

      temp_norm=a**2*crys%vcell/(2d0*(4d0*datan(1d0))**2)*(-gm
     $     /(6*(a**2+gm**2)**3)+gsub/(6*(a**2+gsub**2)**3)+gm/(24*a**2
     $     *(a**2+gm**2)**2)-gsub/(24*a**2*(a**2+gsub**2)**2)+gm/(16*a
     $     **4*(a**2+gm**2))-gsub/(16*a**4*(a**2+gsub**2))+(datan(gm/a
     $     )-datan(gsub/a))/(16*a**5))

      prefac = dsqrt(6d0*random_startvec/(100d0
     $     *temp_norm))

      do l=1,neig
         do j=1, gs%length
            call random_number(temp)
            call random_number(temp2)
            random=temp2*prefac*a/((a**2+gs%ekin(j))**2)
     $           *exp(pi2*cmplx(0.d0,1.d0,kind=8)*temp)
            if(gs%ekin(j).gt.(gsub)**2) then
               if(.not.crys%icomplex) then
                  xvec((l-1)*gs%length+j)=xvec((l-1)
     $                 *gs%length+j)+dble(random)
               else
                  xvec((l-1)*gs%length+j)=xvec((l-1)
     $                 *gs%length+j)+random
               endif
            endif
         enddo
         temp=0d0
         do j=1, gs%length
            temp=temp+abs(xvec((l-1)*gs%length+j))**2
         enddo
         call all_sum_all(temp)
         dsqtemp = 1/dsqrt(temp)
         do j=1, gs%length
            xvec((l-1)*gs%length+j)=xvec((l-1)*gs%length+j)*dsqtemp
         enddo
      enddo

      return
      
      end 
