c
c     @process extchk
c
      subroutine reg_grid_spline(y,n,y2)
c
c     computes the second derivative array y2 for a function
c     on a regular grid spaced 1 
c
c     second derivatives at boundaries set to zero
c
c
c     (1996) F. Mauri B. Pfrommer
c
      implicit none             ! never

      integer n                 ! number of array points

      double precision 
     $     y(n)                 ! function values at 1,2,3....n
c
c     OUTPUT:
c     ------
      double precision 
     $     y2(n)                ! second derivatives 

c     ------------- local variables --------------------------

      double precision p,qn,sig,un
      integer i,k

      double precision, allocatable :: u(:)

      allocate(u(n))

c     ..

      y2(1) = 0.d0
      u(1) = 0.d0

      sig = 0.5d0
      do  i = 2,n - 1
         p = sig*y2(i-1) + 2.d0
         y2(i) = (sig-1.d0)/p
         u(i) = (3.d0* ((y(i+1)-y(i))- (y(i)-y(i-
     $        1)))-sig*u(i-1))/p
      end do

      qn = 0.d0
      un = 0.d0

      y2(n) = (un-qn*u(n-1))/ (qn*y2(n-1)+1.d0)

      do k = n - 1,1,-1
         y2(k) = y2(k)*y2(k+1) + u(k)
      end do

      deallocate(u)

      return

      end
