c
      logical function rest_inv(ipr, n,ntype,
     $         natom,coorat,nameat,tnp,mxdatm)
c
      implicit none
c
c     Restores the inversion symmetry if possible.
c     Alberto Garcia, 1990-1991
c
c     n:   Operation number associated with the inversion
c
      integer n, ntype, mxdatm
      integer natom(ntype)
      double precision coorat(ntype,MXDATM,3)
      character nameat(ntype)*2
      double precision tnp(48,3)

c
c
      integer i, j, k, ipr
c
c
      rest_inv = .FALSE.
c
c
c
      if (n .le. 0) return
c
c     Check whether the inversion has a non-symmorphic translation
c
      if (max(abs(tnp(n,1)),abs(tnp(n,2)),abs(tnp(n,3))) 
     &                      .gt. 1.d-6) then
c
         Rest_Inv = .TRUE.
c
         if(ipr .eq. 1) then
            write(9,'(/,a,//,a,//)') ' Restoring inversion symmetry...',
     &           ' New coordinates:'
         endif
c
c
         do 40 i = 1, ntype
            do 30 j = 1, natom(i)
              do 20 k = 1, 3
                 coorat(i,j,k) = coorat(i,j,k) - 0.5 * tnp(n,k)
   20         continue
              if(ipr .eq. 1) then
                 write(9,9030) nameat(i), j, (coorat(i,j,k),k=1,3)
              endif
 9030         format(1x,a2,' #',i2,':',3f18.12)
   30       continue
   40    continue
c
      endif
c
      if(ipr .eq. 1) then
         write(9,'(/)')
      endif
c
      return
c
      end
