c-*-Fortran-*-
c*
      subroutine setup_local_potential(ipr,
     $     ffts, gs, viondata, vlocfft)

      include 'use.h'
      implicit none             ! implicit? Just say no!
      include 'interface.h'
c
c     INPUT:
c     -----
      integer ipr               ! print flag

      type (fftstruc) ffts      ! work arrays for the FFT
      type (parallel_gspace) gs ! the gspace for which the potential is set up
      complex(kind=8)
     $     viondata(*)          ! the potential in gspace viondata(gs%length)
c
c     OUTPUT:
c     ------

      complex(kind=8)
     $     vlocfft(*)           ! local pot in realspace vlocfft(ffts%r_size)
c
c     
c     Prepares the local part of the hamiltonian in real space: vlocfft
c
c
c     --------- local variables -----------------------------------------
c
      integer  ierr, i

      double precision
     $     dmax, dmin, cmax, cmin, small, warnmax

      parameter (small = 1.0d-12)
c
c     --------------------------------------------------------------------
c

c     fourier transform the local potential. vlocfft contains local part
c     of potential.
c     

      call fourier_transform(-1,
     $     ffts,gs,viondata,vlocfft)

      call check_array(vlocfft, ffts%r_size, dmax, dmin, 
     $     cmax, cmin, small, ierr)



      warnmax = max(abs(cmax),abs(cmin))

      if(ipr.gt.0) then
         if (ierr .ne. 0) 
     $        call warn(271,warnmax,ierr,'setup_local_potential')
         write(9,104) dmax, dmin
         write(9,106) cmax, cmin
         call myflush(9)
      endif
c
      return

 104  FORMAT(/,'  MAX AND MIN OF POTENTIAL ',2F10.4)
 106  FORMAT('  MAX AND MIN COMPLEX COMPONENT   ',2g10.2/)
      END


