c
      subroutine symchk(ipr,ierr,ntrans,mtrx,tnp,flag)
c
c     symchk checks if the symmetry operations defined by
c     mtrx and tnp really forms a group.
c
c     Jan 7, 1990: AG/ 2pi factor removed ! /
c
c
c Out  ierr                returns 0 if no error, otherwise it returns
c                          the number of the suspected operation.
c
c Inp  flag                0 for g-space check, 1 for r-space check
c
C     .. Scalar Arguments ..
      integer ierr, ntrans, flag, ipr
C     ..
C     .. Array Arguments ..
      double precision tnp(48,3)
      integer mtrx(48,3,3)
C     ..
C     .. Arrays in Common ..
      integer mult(48,48), nerr(48)
C     ..
C     .. Local Scalars ..
      double precision pi2, ttest, xdum
      integer i, im, itest, j, k, l, m, maxerr
      character*80 not_a_grp
C     ..
C     .. Local Arrays ..
      integer mtest(3,3)
C     ..
C     .. External Subroutines ..
      external fatal
C     ..
C     .. Intrinsic Functions ..
      intrinsic abs, atan, dble
C     ..
C     .. Common blocks ..
      common mult, nerr
C     ..
c
      not_a_grp = 'The symmetry operations' //
     &            ' do not form a group. Check operation no%i4$\n'
c
      pi2 = 8.d0*atan(1.d0)
c
c      check for duplicate operations
c
      if (ntrans .eq. 1) return
      do 40 i = 2, ntrans
         im = i - 1
         do 30 j = 1, im
            do 20 k = 1, 3
               if (abs(tnp(i,k)-tnp(j,k)) .gt. 1.d-8) go to 30
               do 10 l = 1, 3
                  if (mtrx(i,k,l) .ne. mtrx(j,k,l)) go to 30
   10          continue
   20       continue
            if(ipr .eq. 1) then
               write(9,9000) j, i
            endif
 9000       format(/' symmetry operations',i3,' and',i3,' are equal')
            ierr = i
            call fatal('symchk',not_a_grp,xdum,ierr)
c
            return
c
   30    continue
   40 continue
c
c      construct muliplication table
c
      do 120 i = 1, ntrans
         nerr(i) = 0
         do 110 j = 1, ntrans
            mult(i,j) = 0
c
c      mulitiply i and j
c
            do 70 k = 1, 3
               do 60 l = 1, 3
                  mtest(k,l) = 0
                  do 50 m = 1, 3
                     mtest(k,l) = mtest(k,l) + mtrx(i,k,m)*mtrx(j,m,l)
   50             continue
   60          continue
   70       continue
c
c      check for match
c
            do 100 k = 1, ntrans
               do 90 l = 1, 3
                  do 80 m = 1, 3
                     if (mtest(l,m) .ne. mtrx(k,l,m)) go to 100
   80             continue
   90          continue
               mult(i,j) = k
  100       continue
  110    continue
  120 continue
c
c      if translations not correct set mult(i,j) to -1
c
      if (flag. eq. 0 ) then
c
         if(ipr .eq. 1) then
            write(9,*) 'Checking in g-space'
         endif
      do 160 i = 1, ntrans
         do 150 j = 1, ntrans
            k = mult(i,j)
            if (k .eq. 0) go to 150
            do 140 l = 1, 3
               ttest = tnp(j,l)
               do 130 m = 1, 3
                  ttest = ttest + dble(mtrx(i,m,l))*(tnp(i,m)-tnp(k,m))
  130          continue
               ttest = abs(ttest)
               itest = nint(ttest) 
               if (abs(ttest-dble(itest)) .lt. 1.d-4) go to 140
c     if (abs(ttest-dble(itest)) .lt. 1.d-6) go to 140
               write(9,*) i,j,l,abs(ttest-dble(itest))
               mult(i,j) = -1
c
               go to 150
c
  140       continue
  150    continue
  160 continue
c
      else
c
         if(ipr .eq. 1) then
            write(9,*) 'Checking in r-space'
         endif
      do 560 i = 1, ntrans
         do 550 j = 1, ntrans
            k = mult(i,j)
            if (k .eq. 0) go to 550
            do 540 l = 1, 3
               ttest = tnp(i,l) - tnp(k,l)
               do 530 m = 1, 3
                  ttest = ttest + mtrx(i,l,m)*tnp(j,m)
  530          continue
               itest = nint(ttest) 
               if (abs(ttest-dble(itest)) .lt. 1.d-4) go to 540
c               if (abs(ttest-dble(itest)) .lt. 1.d-6) go to 540
               write(9,*) i,j,k,l,abs(ttest-dble(itest))
               mult(i,j) = -1
c
               go to 550
c
  540       continue
  550    continue
  560 continue
c
      endif
c
c      check multiplication table
c
      do 180 i = 1, ntrans
         do 170 j = 1, ntrans
            if (mult(i,j) .gt. 0) go to 170
            nerr(i) = nerr(i) + 1
            nerr(j) = nerr(j) + 1
  170    continue
  180 continue
c
c      find element with max error
c
      ierr = 0
      maxerr = 0
      do 190 i = 1, ntrans
         if (nerr(i) .le. maxerr) go to 190
         maxerr = nerr(i)
         ierr = i
  190 continue
      if (ierr .eq. 0) return
      if(ipr .eq. 1) then
         write(9,9010)
 9010    format('1Multiplication table',/)
      do 200 i = 1, ntrans
         write(9,9020) (mult(i,j),j=1,ntrans)
 9020    format(1x,48i2)
  200 continue
      endif
      call fatal('symchk',not_a_grp,xdum,ierr)
c
      return
c
      end
