c
      subroutine symmetrize_crystal(crys, syms)

      include 'use.h'
      implicit none
      include 'interface.h'

c                     
c     INPUT
c     -----
c
      type (symmetry) syms
c
c     INPUT/OUTPUT
c     ------------

      type (crystal) crys

c
c     DESCRIPTION:
c     -----------
c
c     symmetrizes the atomic coordinates and the lattice vectors (not
c     yet) according to the symmetry  operations.
c
c     1998 Bernd Pfrommer Bugs Inc. 
c
c
c     ------------------------------------------------------------------
c
      integer i, j, k, l, m, kk, idif

      double precision cro(3), twopi, pi, xdif, eps, drc(3)
      parameter ( pi = 3.141592653589793d0, twopi = 2.0d0*pi)
      parameter ( eps = 1.0d-6)

      double precision, allocatable :: rtmp(:,:,:)

      allocate(rtmp(3,crys%mxdatm,crys%ntype))

      do j=1, crys%ntype
         do k=1, crys%natom(j)
            rtmp(:,k,j) = crys%rat(:,k,j)/twopi
         end do
      end do

      crys%rat=0

      do j=1, crys%ntype
         do k=1, crys%natom(j)
            do i=1, syms%ntrans
c
c                     -1
c            find mtrx    * (rat - tnp)
c
               do l=1,3
                  cro(l) = 0
                  do m=1,3
                     cro(l) = cro(l) + dble(syms%mtrx(m,l,i)) *
     $                    (rtmp(m,k,j)-syms%tnp(m,i)/twopi)
                  end do
               end do
c
c     look for matching atom
c

               do l=1, crys%natom(j)
                  do m=1,3
                     xdif = abs(cro(m)-rtmp(m,l,j))
                     idif = xdif + eps
                     if (abs(xdif-dble(idif)) .gt. eps) goto 16
                  end do
                  kk = l
                  goto 17
 16               continue
               end do
               write(9,*) 'subroutine symmetrize_coordinates'
               write(9,*) 'unable to find equivalent atom for k=',k
               write(9,*) 'please symmetrize coordinates and retry.'
               stop
 17            continue
c
c              add up the transformed coordinates
c     
               drc    = cro(:) - rtmp(:,kk,j)

               drc(1) = drc(1) - dble(nint(drc(1)))
               drc(2) = drc(2) - dble(nint(drc(2)))
               drc(3) = drc(3) - dble(nint(drc(3)))

               cro = rtmp(:,kk,j) + drc

               crys%rat(:,kk,j) = crys%rat(:,kk,j) + cro(:)
              
            end do
         end do
      end do

      crys%rat = crys%rat/dble(syms%ntrans)*twopi

      deallocate(rtmp)

c
c     symmetrize lattice vectors 
c

      end



