c
      subroutine symmetrize_local(ng, data,
     $     ns, inds, mstar, phase, work, gsinv) 
c
c     enforces correct symmetry, and also that data(G)=conjg(data(-G))
c
c     1995 by Bernd Pfrommer, while at UCB

      implicit none             ! implicit? Just say no!

c     INPUT:
c     -----

      integer
     $     ng,
     $     ns,                  ! number of stars 
     $     gsinv(ng),           ! inversion information
     $     inds(ng),            ! star index for each gvector
     $     mstar(ns)            ! size of stars

      complex(kind=8)
     $     phase(ng)            ! phase factors for mixing gvectors

C
c     INPUT/OUTPUT:
c     -------------

      complex(kind=8)
     $     data(ng)             ! the data to be symmetrized

c     WORK ARRAYS:
c     -----------
      complex(kind=8)
     $     work(ns)

c     ------------------ local variables ------------------------

      integer i,ii
      complex(kind=8) dcmp
      
c     ------------------ first symmetrize with symmetry operations --------

      do i=1,ns
         work(i)=(0.d0, 0.d0)
      end do

      do i=1, ng
         work(inds(i))=work(inds(i)) + data(i)*phase(i)
c         if(inds(i).eq.42) print*,i,inds(i),
c     $        data(i),phase(i),data(i)*phase(i)
      end do

      do i=1,ns
         work(i)=work(i)/dble(mstar(i))
      end do

c      write(9,*) 'symmetrization:'

      do i=1, ng
c         dcmp=data(i)
         data(i)=work(inds(i))*conjg(phase(i))
c         if(inds(i).eq.42) write(9,*)  i,inds(i), dcmp,data(i),
c     $        work(inds(i)), phase(i) 
      end do

c
c     now symmetrize data(G)=conjg(data(-G))
c
      
      do i=1, ng
         ii=gsinv(i)
         if((ii.gt.ng).or.(ii.le.0)) then
            write(9,*) 'symmetrize_local: inversion array is incorrect'
            stop
         endif

         dcmp = 0.5d0 * (data(i)+conjg(data(ii)))
         data(i)  = cmplx(dble(dcmp), aimag(dcmp),kind=8)
         data(ii) = conjg(data(i))
      end do
      return
      
      end
 
