c
      subroutine symmetrize_scalar_global(scal,gs)
c
c
      use all_to_all_module
      include 'use.h'
      implicit none             ! implicit? Just say no!
      include 'interface.h'
      include 'all_to_all.h'

c     INPUT:
c     -----
c
      type (parallel_gspace) gs ! the gspace corresponding to the data

c     INPUT/OUTPUT:
c     ------------
c
      complex(kind=8)
     $     scal(gs%length) ! the quantity to be symmetrized

c
c     DESCRIPTION:
c     -----------
c
c     Symmetrizes a scalar field across multiple processors.
c     
c     1996 Bernd Pfrommer
c     1997 changes by Francesco Mauri

c     ---------------------- local variables ----------------------------

      complex(kind=8), allocatable ::
     $     symscal(:)

      integer i, ii

      if (.not.gs%istar) return ! Francesco Mauri's shortcut

      allocate(symscal(gs%nstar))
      symscal=0
      do i=1, gs%length
         ii=gs%inds(i)
         symscal(ii) = symscal(ii) +
     $        scal(i)*gs%phase(i)
      end do

      symscal(:)=symscal(:)/dble(gs%mstar(:))

      call all_sum_all(symscal,gs%nstar)

      do i=1, gs%length
         scal(i) = symscal(gs%inds(i))*conjg(gs%phase(i))
      end do


      deallocate(symscal)

      end
