C*
C*
      subroutine symmetrize_tensor(tens, crys, syms)
c
c     symmetrizes the tensor tens
c
      use flibcalls_module
      include 'use.h'
      implicit none             ! implicit? Just say no!
      include 'interface.h'

c     INPUT:
c     -----
c
      type (crystal) crys
      type (symmetry) syms
c
c     INPUT/ OUTPUT:
c     -------------
c
      
      double precision 
     $     tens(3,3)

c
c     -------- local variables ---------
c     

      integer nops, n

      double precision 
     $     symtens(3,3), d, alf(3,3), alfm1(3,3)

      symtens=0

      nops=0
      do n=1, syms%ntrans
         alf=syms%rsymmat(:,:,n)
         alfm1=alf
         call invers(alfm1,d)
         if(abs(d).gt.0.d0) then
            nops = nops+1
            symtens = symtens + matmul(alf,matmul(tens,alfm1)) 
         else
            write(9,*) 'warning: symmetry operation',n,'is singular'
         endif
      end do

      tens = symtens/dble(nops)

      end

