      subroutine writegsdat2(ipr,
     $     gs, data, ldnvecs, nvecs,nspin,filename,namelen)

      use all_to_all_module
      include 'use.h'
      implicit none             ! implicit? Just say no!
      include 'interface.h'
c---------------------------------------------------------------------
!J    for VXC and CD95 output in pwmain.fp, always the case ipr=0,
!J    data(1,1,1:crys%spin),ldnvecs=nvecs=1. nspin should be 1 or 2       
c     writes a data array to disk such that it can be read and used in 
c     later calculations
c
c     .. HEADER ..
c     
c      g1 g2 g3 ((data(i1,n,is), n=1,nvecs), is=1,nspin)
c      g1 g2 g3 ((data(i2,n,is), n=1,nvecs), is=1,nspin)
c      ...
c      g1 g2 g3 ((data(il,n,is), n=1,nvecs), is=1,nspin)

 
c     INPUT:
c     -----

      integer 
     $     ipr,                 ! print flag
     $     namelen,             ! length of filename
     $     nvecs,               ! number of vectors
     $     ldnvecs,             ! leading dimension
     $     nspin                ! number of spins
    
      type (parallel_gspace)
     $     gs                   ! the gspace on which the data is set up

      complex(kind=8), dimension (gs%length,ldnvecs,nspin) ::
     $     data ! data that should be written to file

      character*(*) filename    ! name of file to be written

c     ---------------- local variables ----------------------------------
       
      integer
     $     i,j,k, iproc,
     $     wios, n, is,igs2

      character*24 bdate
      character*8 btime
      character*255 buffer
c
c     ----- variables for the gspace loop ---------
c
      integer
     $     igv(4),fftn(4), ffth(4),igv3, irod,iord,igs

c

      buffer = filename(1:namelen)

      fftn(1:3)=gs%fftsize(1:3)
      fftn(4)=gs%fftsize(3)
      ffth(:)=fftn(:)/2


c     -------- write header -----------------

      if(gs%myproc.eq.0) then
         open(unit=21,file=buffer, err=99, iostat=wios,
     $        status='unknown',form='unformatted')
         rewind(21)
         call zedate(bdate)     ! get time and date
         call zetime(btime)     !
         write(21) bdate, btime
         write(21) nvecs, nspin
         write(21) gs%nproc
         close(21)
      endif
c     -----------------------------------------------------------------------
c
c     Now the processors write gspace and gsarr values out on disk
c     
c      do iproc = 0, gs%nproc-1     ! loop over processors

c         if(iproc.eq.gs%myproc) then

c            open(unit=21,file=buffer,
c     $           err=99, iostat=wios,
c     $           position = 'append',
c     $           status='old',form='unformatted')

c           loop over g-vectors 
c            write(21) gs%length
            igs = 0 
            do iord=1, gs%lorder ! loop through x/y gspace 
               irod=gs%order(1,iord)
               igv(1)= irod/gs%fftsize(2)
               igv(2)= mod(irod,gs%fftsize(2))
               igv(3)= gs%order(2,iord)
               igv(4)= gs%order(3,iord)
               igv(:)= mod(igv(:)+ffth(:),fftn(:))-ffth(:) 
               do igv3=igv(3),igv(4) ! loop over z axis
                  igs = igs + 1
c                  write(21) igv(1),igv(2),igv3
c                  write(9,*) igv(1),igv(2),igv3
c                  write(21) ((data(igs,n,is),
c     $                 n=1,nvecs), is=1,nspin)
c                  write(9,*) ((data(igs,n,is),
c     $                 n=1,nvecs), is=1,nspin)
               end do
            end do
            write(9,*) 'wrote',igs,'components'
c            if(gs%nproc.gt.1)  close(21)
          
c          end if
c         if(gs%nproc.gt.1)  call parallel_barrier()
c figured out how many g-vectors on this processor
       igs2 = igs 
       do iproc = 0, gs%nproc-1     ! loop over processors

          if(iproc.eq.gs%myproc) then

            open(unit=21,file=buffer,
     $           err=99, iostat=wios,
     $           position = 'append',
     $           status='old',form='unformatted')

c           loop over g-vectors 
            write(21) igs2
            igs = 0 
            do iord=1, gs%lorder ! loop through x/y gspace 
               irod=gs%order(1,iord)
               igv(1)= irod/gs%fftsize(2)
               igv(2)= mod(irod,gs%fftsize(2))
               igv(3)= gs%order(2,iord)
               igv(4)= gs%order(3,iord)
               igv(:)= mod(igv(:)+ffth(:),fftn(:))-ffth(:) 
               do igv3=igv(3),igv(4) ! loop over z axis
                  igs = igs + 1
                  write(21) igv(1),igv(2),igv3
c                 write(9,*) igv(1),igv(2),igv3
                  write(21) ((data(igs,n,is),n=1,nvecs),is=1,nspin)
                  write(9,*) ((data(igs,n,is), n=1,nvecs),is=1,nspin)
               end do
            end do
            if(gs%nproc.gt.1)  close(21)
          
         end if
         if(gs%nproc.gt.1)  call parallel_barrier()
      end do

      if(gs%myproc.eq.0) then
         if(gs%nproc.gt.1) then
            open(unit=21,file=buffer,
     $           position='append',
     $           status='old',form='unformatted')
         endif
         write(21) -1234567, 0, 0 ! mark end of record
         close(21)
      endif
      
      if(gs%nproc.gt.1) then
         call parallel_barrier()
      endif

      if(ipr.ge.1)  write(9,100) filename




      return

 99   write(0,*) 'open failed in writegsdat!'
      write(0,*) 'ios error code:', wios
      stop


 100  format(/' SAVED DATA TO FILE ',a)

      end 



