c
c     =================================================================
c
      program cdcray2sgi


c
c     1997 Bernd Pfrommer
c
      implicit none             ! never
c
c     DESCRIPTION:
c     -----------
c
c     Converts a CD file from the cray to the sgi.
c     The cd file has to be generated by  paratec v3.0  or later.
c

      integer 
     $     inl, outl, nvecs, nspin, idat, ig(3),n,is,nargs,
     $     ilen,ierror

      complex(kind=8), allocatable :: data(:,:)

      character*80 infile, outfile
      character*24 bdate
      character*8 btime

      m4_ifdef([T3E],[
      integer IPXFARGC
      external IPXFARGC
      external PXFGETARG
      ],[
      integer iargc
      external iargc
      external getarg
      ])

      external chrlen
c
c     ------------------------------------------------------------------
c
      m4_ifdef([CRAY],[
      call asnunit(8,'-F f77 u:50',ierror)
      ],[
       write(9,*)
     $      'THIS PROGRAM MUST BE COMPILED  AND RUN ON THE CRAY'
       stop
       ])

      m4_ifdef([T3E],[
      nargs = ipxfargc()
      ],[
      nargs = iargc()])
      if (nargs .ne. 2) then
         write(0,*) 'Usage: cdcray2sgi name_charge_cray name_charge_sgi'
         stop 
      endif
      m4_ifdef([T3E],[
      call pxfgetarg(1, infile, ilen, ierror)
      call pxfgetarg(2, outfile, ilen, ierror)
      ],[
      call getarg(1,infile)
      call getarg(2,outfile)
      ])

c
c     get file names from command line arguments
c
      call chrlen(infile,0,inl)
      call chrlen(outfile,0,outl)

c
c     open units
c
      open(unit=7,file=infile(1:inl),form='unformatted')
      open(unit=8,file=outfile(1:outl),form='unformatted')

c
c     read and write header
c     
      rewind(7)
      rewind(8)
      read(7,end=911) bdate, btime
      write(8) bdate,btime
      write(9,'(''date:'',a24,a8)') bdate
      read(7,end=911) nvecs, nspin
      write(8) nvecs, nspin
      write(9,'(''number of data sets:'',' //
     $     'i6,'', number of spins:'',i3)') 
     $     nvecs, nspin
c
c     read and write the data itself
c
      allocate(data(nvecs,nspin))

      idat =0
      do while(1.eq.1)
         read(7,end=911) ig(1),ig(2),ig(3)
         write(8) ig(1),ig(2),ig(3)
         if(ig(1).eq.-1234567) goto 123
         idat = idat+1
         read(7,end=911) 
     $        ((data(n,is), n=1,nvecs), is=1,nspin)
         write(8) ((data(n,is), n=1,nvecs), is=1,nspin)
      end do

 123  continue

      write(9,*) 'number of gvectors converted:',idat

      close(7)
      close(8)

      deallocate(data)

      write(9,*) 'conversion cray => sgi successful.'
      stop

c
c     in case of error
c

 911  continue
      write(0,*)
     $     'ERROR: CRAY CHARGE DENSITY FILE ENDED PREMATURELY'
      deallocate(data)
      stop


      end

c
c     ======================================================================
c
c
      subroutine chrlen(string,nchar,lchar)
C
      implicit none
c
c     INPUT:
c     -----
      character string*(*)
      integer 
     $     nchar                ! max number of characters, unless 0
c
c     OUTPUT:
c     ------
      integer
     $     lchar                ! length of string
c
c     DESCRIPTION:
c     -----------
c
c     chrlen accepts a string of nchar characters and returns lchar,
c     the length of the string up to the last nonblank, nonnull.
c
c
      integer i, ncopy 
      character char*1
c
      ncopy=nchar
      if(ncopy.le.0)ncopy=len(string)
c
      do i=1,ncopy
        lchar=ncopy+1-i
        if(string(lchar:lchar).ne.' '.and.
     *     string(lchar:lchar).ne.char(0))return
      end do

      lchar=0
      return
      end


