c     ---------------------------------------------------------------
c    
c
c     converts spin-unpolarized charge density
c
c       from      paratec v2.3 or earlier 
c       to        paratec v3.0 or later
c
c     old charge must be in file CD
c     new charge will be in file CD.new
c     
c
      program cdold2new
      
c
c     1996 by Bernd Pfrommer
c
      implicit none             
c
c     ----------------- local variables --------------------------------
c
      character*24 bdate
      character*8 btime
      
      integer idat,ig(3),izero
      complex(kind=8) rdata,cdtot

c     -----------------------------------------------------------------


      open(21,file='CD', form='unformatted')
      open(22,file='CD.new', form='unformatted')

c
c     deal with headers
c
      read(21)  bdate,btime
      write(22) bdate,btime
      write(22) 1,1

      write(9,100) 'CD', bdate
c
c
c     
      izero=0
      cdtot=0

      idat=0
      do while(1.eq.1)
         read(21,end=123) ig(1),ig(2),ig(3),rdata
         write(22) ig(1),ig(2),ig(3)
         if(ig(1).eq.-1234567) goto 123
         write(22) rdata
         idat=idat+1
         if((ig(1).eq.0).and.(ig(2).eq.0).and.(ig(3).eq.0)) then
            izero=idat
            cdtot=rdata
         endif
      end do
 123  continue


      write(9,200) idat
      if(izero.gt.0) then
         if(aimag(cdtot).gt.1d-10) write(9,350)aimag(cdtot)
         write(9,300) dble(cdtot),izero
      else
         write(9,400)
      endif

      close(21)
      close(22)

 100  format(/' READING DATA FROM FILE: ',A,
     $     /' WRITTEN ON THE ',a24)
 200  format(/' CONVERTED ',i12,' G-VECTORS')
 300  format(/' TOTAL CHARGE IN UNIT CELL:', f12.6,' ON GVECTOR',i12)
 350  format(/' *** WARNING: TOTAL CHARGE IS COMPLEX:',g12.6)
 400  format(/' *** SEVERE WARNING: COULD NOT FIND G=0 COMPONENT!')
      end





