c 
      program kbascbin

c
c     converts ascii pseudopotential file to binary file suitable
c     for Kleinman-Bylander codes
c
c     modified 1995 Bernd Pfrommer
c     modified 1996 Bernd Pfrommer
c
c
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
c
      PARAMETER (NRMAX=2000,LMAX=6)
c
      dimension VQL(NRMAX),AR(NRMAX,LMAX),CDC(NRMAX),CDD(NRMAX)
      dimension INORM(LMAX)
c

      m4_ifdef([T3E],[
      integer IPXFARGC
      external IPXFARGC
      external PXFGETARG
      ],[
      integer iargc,nargs
      external iargc
      external getarg
      ])

      CHARACTER*2 xCORR,xAMEAT 
      CHARACTER*3 xREL
      CHARACTER*4 xICORE 
      CHARACTER*10 xRAY(6),xTITLE(7)
      character*255 ascfile, binfile

      logical inewkb            ! indicates if done with newkbconv
      integer lo(lmax)
c
c
c     -------------------------------------------------------------
c
      m4_ifdef([T3E],[
      nargs = ipxfargc()
      ],[
      nargs = iargc()])
      if (nargs .ne. 2) then
         write(0,*) 'Usage: kbascbin ascfilename binfilename'
         stop 
      endif
      m4_ifdef([T3E],[
      call pxfgetarg(1, ascfile, ilen, ierror)
      call pxfgetarg(2, binfile, ilen, ierror)
      ],[
      call getarg(1,ascfile)
      call getarg(2,binfile)
      ])

      open(19,file=ascfile,
     $     status='unknown',form='formatted')
c
      read(19,1234) xAMEAT,xCORR,xREL,xICORE
 1234 format(1x,a2,1x,a2,1x,a3,1x,a4)
      read(19,1235) (xRAY(I),I=1,6)
 1235 format(6a10)
      read(19,1236) (xTITLE(I),I=1,7)
 1236 format(7a10)
      read(19,1237) IZNUC,NQL,DELQL,VQL0
 1237 format(2(1x,i5),2(1x,f20.12))
      read(19,2237)  NORB,(INORM(I),I=1,NORB)
 2237 format(10i5)
      read(19,1238) (VQL(J),J=1,NQL)
 1238 format(2(1x,f25.15))
      do  212 i=1,NORB
          read(19,1238) (AR(j,i),j=1,NQL+1)
 212  continue
      read(19,1238) (CDC(j),j=2,NQL+1)
      read(19,1238) (CDD(j),j=2,NQL+1)
      inewkb = .true.
      read(19,2237,end=9456) (lo(j),j=1,norb)
      goto 9457
 9456 inewkb = .false.
 9457 continue

c
c  Write the transforms to file `potfourkb.dat'
c
      open (9,file=binfile,form='unformatted')
c
      WRITE(9) xAMEAT,xCORR,xREL,xICORE,(xRAY(I),I=1,6),
     1 (xTITLE(I),I=1,7)

      WRITE(6,*) xAMEAT,xCORR,xREL,xICORE,(xRAY(I),I=1,6),
     1 (xTITLE(I),I=1,7)

      write(6, 678) iznuc,nql, delql, vql0  
 678  format('iznuc=',i3,',  nql=',i5,', delql=',f9.5,', vql0=', f9.5)

      WRITE(9) IZNUC,NQL,DELQL,VQL0

      write(6,*) 'inorms:'
      WRITE(6,'(i3)') NORB
      write(6,'(i3)') (INORM(I),I=1,NORB)

      WRITE(9) NORB,(INORM(I),I=1,NORB)

      write(6,*) 'first few components of local pot:'
      WRITE(6,'(i6)') NQL
      write(6,'(g12.4)') (vql(j), j=1,6)

      WRITE(9) (VQL(J),J=1,NQL)
      DO 210 I=1,NORB
        WRITE(9) (AR(J,I),J=1,NQL+1)
 210  CONTINUE
      write(6,*) 'first few components of core charge density:'
      WRITE(6,'(i6)') NQL
      write(6,'(f12.6)') (cdc(j), j=2,7)

      WRITE(9) (CDC(J),J=2,NQL+1)

      write(6,*) 'first few components of valence charge density:'
      WRITE(6,'(i6)') NQL
      write(6,'(f12.6)') (cdd(j), j=2,7)

      WRITE(9) (CDD(J),J=2,NQL+1)

      if(inewkb) then
         write(6,*) 'pseudopotential done with newkb '
         write(9) (lo(j),j=1,norb)
      endif

      CLOSE(UNIT=9)
c
      end
