#
# Authors:	Bernd Pfrommer
#
# Description:	Paratec makefile variables.
#
# Version:	@(#)vars.mk 1.2 98/06/05
#

MAKELEVEL	= 0

TARGETS		= paratec microbench tools test
TOOLS		= cdascbin cdbinasc cdold2new kbascbin kbbinasc 

INCDIRS 	= -I$(DEPTH)/include

F90OBJMDIR	= $(DEPTH)/obj/f90objm
F90POBJMDIR	= $(DEPTH)/obj/f90pobjm
F90OBJDIR	= $(DEPTH)/obj/f90obj
F90POBJDIR	= $(DEPTH)/obj/f90pobj
F90OBJODIR	= $(DEPTH)/obj/f90objo
F90POBJODIR	= $(DEPTH)/obj/f90pobjo

COBJDIR		= $(DEPTH)/obj/cobj
COBJODIR	= $(DEPTH)/obj/cobjo

EXECDIR		= $(DEPTH)/bin
SHAREDDIR	= $(DEPTH)/src/shared
#
# sources that the m4 preprocessor should include
#
M4DIR		= $(DEPTH)/src/macros
M4GLOBAL   	= $(M4DIR)/global/m4undef.m4h 
M4FFT		= $(M4DIR)/fft/fft_macros.m4h
M4FILES		= $(M4FFT) $(M4GLOBAL)

# 
# flags that m4 should use
#

M4FLAGS 	= $(M4SYSFLAGS) $(M4MSGPASS) $(M4SCALAPACK)

#
# libraries
#
LIBS 		= $(MATHPARALLEL) $(MATHLIBS) $(CLIBS) $(MSGPASSLIBS) 
CINC		= $(MSGPASSCINC)
FINC		= $(MSGPASSFINC)

#
# flavor (determines name of executable)
#
FLAVOR		= $(MSGPASSFLAVOR)

.SUFFIXES: .fp .ph .m4h $(SUFFIXES)
